*----------------------------------------------------------------------------
*- Version....: ACCPAC Pro Series 7.30.01
*- File Name..: $Workfile:   pe.prg  $
*- VCS Level..: $Revision:   1.22  $
*- Last Update: $Date:   20 Apr 2006 10:15:56  $
*----------------------------------------------------------------------------
*- Copyright (C) 2004 ACCPAC International, Inc.  All Rights Reserved.
*----------------------------------------------------------------------------
*- App ID.....: PE
*- App Name...: Production Entry
*----------------------------------------------------------------------------
*- Synopsis...: Production Entry startup and menu processing.
*----------------------------------------------------------------------------
*- Called By..: PRO.PRG
*----------------------------------------------------------------------------
*- Calls......: c_flgda(),  g_dspalt(), g_dspbar(), g_dspst(),  icproc.prg, 
*-              l_intsbt,   l_pepcls(), l_rlspe(),  l_varpe(),  peopnf.prg, 
*-              pesyst.prg, symedt.prg, u_chkpv(),  u_setus()
*----------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: lc_pad,   from PAD()   or literal value
*-              lc_popup, from POPUP() or literal value
*-              ln_bar,   from BAR()   or literal value
*----------------------------------------------------------------------------

#DEFINE Cl_Enable          .t.

PARAMETERS lc_pad, ;
           lc_popup, ;
           ln_bar

#include events.h
#include global.h

*-- Check for defined variables
IF PARAMETERS() < 3
  *-- Display stub message
  CLEAR
  ? "This program must be called by PRO.PRG"
  WAIT
  CLEAR
  QUIT
ENDIF

LOCAL ll_ModalForm, ;
      ll_ModalsOpen, ;
      lc_tfile

lc_tfile = ""

*-- Disable menu pads
gl_PadsOff = .t.

*-- Will this be a modal form
ll_ModalForm = (NOT gl_MdiLoad OR go_Cop.m_ModalOpen())

*-- Reset mdi flag
gl_MdiLoad = .f.

IF ll_ModalForm
  *-- Disable toolbar
  DO g_dspbar WITH NOT Cl_Enable
ENDIF

*-- Reset trial status for individual application
RELEASE gl_trial
PUBLIC gl_trial
gl_trial = .f.

*-- Support for Field Length Changer
RELEASE gn_custlen, ;
        gn_doclen, ;
        gn_itemlen, ;
        gn_loctlen, ;
        gn_lotlen, ;
        gc_extfldr

PUBLIC  gn_custlen, ;
        gn_doclen, ;
        gn_itemlen, ;
        gn_loctlen, ;
        gn_lotlen, ;
        gc_extfldr

*\ [1 Line] PTR# 73738 02/10/04 TIBI Used picture variable instead of d_retfd
gn_custlen = LEN(gc_CVNoPic)
gn_doclen  = VAL(d_retfd("PETRAN", "WONO", 6))
*\ [1 Line] PTR# 73738 02/10/04 TIBI Used picture variable instead of d_retfd
gn_itemlen = LEN(gc_ItemPic)
gn_loctlen = VAL(d_retfd("PETRAN", "WLOCTID", 6))
gn_lotlen  = VAL(d_retfd("PETRAN", "WLOTNO", 6))

*-- External file path TIRM
gc_extfldr = JUSTPATH(gc_sycinst) +"\EXTERNAL\"

IF TYPE("lc_parm") = "U"
  PRIVATE lc_parm
  lc_parm = ""
ENDIF

IF TYPE("ln_acslvl") <> "N"
  *-- If this is initial call to PE.PRG, ln_acslvl won't have been
  *-- initialized by PEMAIN.MPR yet.
  PRIVATE ln_acslvl
  ln_acslvl = 2
ENDIF

IF TYPE("ll_dspwk") = "U"
  PRIVATE ll_dspwk
  ll_dspwk = .f.
ENDIF

IF TYPE("lc_prg") = "U"
  PRIVATE lc_prg
  lc_prg = ""
ENDIF

IF TYPE("lc_chosen") = "U"
  PRIVATE lc_chosen
  lc_chosen = " "
ENDIF

IF TYPE("lc_title") = "U"
  PRIVATE lc_title
  lc_title = ""
ENDIF

IF TYPE("lc_title2") = "U"
  PRIVATE lc_title2
  lc_title2 = ""
ENDIF

*-- Save calling POPUP name
gc_popup = POPUP()

DO CASE
  CASE lc_popup = ".INIT"
    *-- Initialize application - direct call to local proc
    PRIVATE lc_task
    lc_task = gc_task

    IF NOT go_SQL.m_IsUsed("a_Sydapp")
      *-- Open the application file
      = g_opnfl(gc_idrvdbf + "sydappl", "a_sydapp" , .f., .f., ;
                Cc_NullStr)
    ENDIF

    gc_task = ALLTRIM(a_sydapp->descrip) + " System"
    lc_prg  = "l_intsbt"
    lc_parm = ["PE", "] + ALLTRIM(a_sydapp->descrip) + ["]
    ll_dspwk  = .t.

    *-- Check SYRFRXS for PE report forms
    DO l_addfrx

    *-- Qualify filename with the correct path for VFP or Client-server
    d_setfl("SYCCMN", "", 4, @lc_tfile)

  CASE lc_popup = ".SYST"
    *-- Call xxSYST directly, this is a rerouted call from PRO or SMFDAT
    lc_task = gc_task
    gc_task = gc_adesc + " Setup Information"

    *-- Save menu setting and turn it off if it is on
    gx_sysoff = gl_sysoff
    gl_sysoff = .t.

    IF lc_pad = "ADD"
      gc_applid = lc_applid
  
      IF NOT gl_lnTax
        DECLARE ga_TaxRate[2], ;
                ga_TaxAble[2], ;
                ga_TaxSubt[2], ;
                ga_TaxAcct[2]
      ENDIF

    ENDIF

    IF TYPE("gc_peprgdv") = "U"
      gc_peprgdv = gc_adrvprg
    ENDIF

    *-- Call Setup information screen
    WITH g_newobj("cntCallpesyst", gc_peprgdv + "pebase")
      .m_Reset()

      *-- Set parameters
      *-- Form management settings
      .sl_Modal   = .t.
      .sc_ApplID  = gc_ApplID
      .sc_CompID  = gc_CompID
      .pc_task    = lc_pad

      *-- Run form
      .m_Run()
    ENDWITH

    *-- Called l_dfmpe to refresh menu after calling setup information because
    *-- some global variables are changed during setup are not refreshed in menu
    *-- like Bills of materials
    DO l_dfmpe

    gl_sysoff = gx_sysoff

    *-- Reset variables
    lc_procid = ""
    lc_prg    = ""
    ln_acslvl = 2

  CASE lc_popup = ".PCLS"
    *-- Close period
    lc_prg  = "l_pepcls"
    lc_parm = lc_pad

  CASE lc_popup = ".RESET"
    *-- Reset companies

    IF NOT c_flgda("", ;
                   gc_compid, ;
                   .t., ;
                   gn_retry, ;
                   0)
      *-- Check system function or needs file update run
      DO g_dspalt WITH "You will be returned to operating system.", 3

      *-- Quit to OS
      DO g_extos

    ELSE

      *-- If user IDs being used
      IF gl_loginr
        *-- Reset current user company and application
        DO u_setus WITH gc_userid, ;
                        gc_compid, ;
                        gc_applid, ;
                        .f.
      ENDIF

      *-- Define global variables
      DO l_varpe

      *-- Open files
      *# DOCCODE DO peopnf
      DO (gc_peprgdv + "peopnf") WITH .t.

      *-- Set date format to MM/DD/YY for compatibility with application code
      SET CENTURY OFF

    ENDIF

  CASE lc_popup = ".EXIT"
    *-- Exit application, cleanup
    DO l_rlspe

ENDCASE

*-- gc_procid set to "" at beginning of procedure.
*-- If still empty here, no access check required and ln_acslvl is still 2
IF NOT EMPTY(gc_procid)
  *-- Call privilege check
  ln_acslvl = u_chkpv(gc_userid, ;
                      gc_procid, ;
                      gc_compid, ;
                      DATE(), ;
                      TIME(), ;
                      ll_dspwk)
ENDIF

*\ PEPRG501 01 11/13/01 DLAH Ignore check for date window if compid is blank
IF ln_acslvl < 2 AND NOT (ln_acslvl = 1 AND EMPTY(gc_compid))
  lc_msg = "User " + ALLTRIM(gc_userid) + " does not have access to "

  IF ln_acslvl = 1
    lc_msg = "User " + ALLTRIM(gc_userid) + " outside privilege window for "
  ENDIF

  gc_procid = gc_applid

  DO g_dspalt WITH lc_msg + gc_oseol + gc_task, 2

  *-- Reset to exit to keep status bar from implying successful entry
  IF lc_popup = ".INIT"
    gc_task = lc_task
    *-- Display status bar
    DO g_dspst WITH gc_task, ;
                    .f., ;
                    gn_msgline, ;
                    gc_applid, ;
                    gc_compid, ;
                    gc_userid

    lc_popup = ".EXIT"

  ENDIF

ELSE

  *-- ln_acslvl is 2 indicating access to process available
  IF NOT EMPTY(lc_prg)
    *-- Display status bar
    DO g_dspst WITH gc_task, ;
                    .f., ;
                    gn_msgline, ;
                    gc_applid, ;
                    gc_compid, ;
                    gc_userid

    *-- Disable System menu
    gl_sysoff = ll_ModalForm

    *-- Used call component to call report program
    DO CASE
      CASE "PEREPT" $ UPPER(lc_prg)

        WITH g_NewObj('sbtrptcall', 'sbtcall')
          .m_Reset()
          .pc_program = "ICPROC"
          .pc_param1  = lc_prg
          .pc_param2  = IIF(EMPTY(lc_parm), "", lc_parm)
          .m_Run()
        ENDWITH

      OTHERWISE

        *-- If no parameter specified
        IF EMPTY(lc_parm)

          *-- If specified program is an internal procedure, e.g. from PRO.PRG
          IF UPPER(LEFT(lc_prg, 2)) = "L_"
            *-- Call the procedure directly
            DO (lc_prg)
          ELSE
            *-- If a call to a program file, route the call through ICPROC.
            DO (gc_icprgdv + "icproc") WITH (lc_prg), ""
          ENDIF

        ELSE

          *-- If there are parameters
          DO CASE
            CASE  UPPER(LEFT(lc_prg, 2)) = "L_" AND "," $ lc_parm
              *-- Call to an internal proc with multiple parms
              DO (lc_prg) WITH &lc_parm.
            CASE  UPPER(LEFT(lc_prg, 2)) = "L_"
              *-- Call to an internal proc with single parm
              DO (lc_prg) WITH lc_parm
            OTHERWISE
              *-- Call external program through ICPROC
              DO (gc_icprgdv + "icproc") WITH (lc_prg), lc_parm
          ENDCASE

        ENDIF && EMPTY(lc_parm)

    ENDCASE

    *-- Disable escape in case inadvertantly set on in subprogram
    SET ESCAPE OFF

  ENDIF && NOT EMPTY(lc_prg)

ENDIF && ln_acsval < 2

IF ll_ModalForm

  *-- Check if any modals still open
  ll_ModalsOpen = go_Cop.m_ModalOpen()

  IF NOT ALLTRIM(UPPER(lc_popup)) $ ".CLRBAL.PCLS.SYST"
    *-- Enable System menu if no modal forms open
    gl_sysoff = ll_ModalsOpen
  ENDIF

  IF lc_popup <> ".EXIT" AND NOT EMPTY(lc_prg)
    *-- Display status bar

    *-- Display status bar if no more modal forms
    IF NOT ll_ModalsOpen

      IF lc_popup <> ".PCLS"
        gc_task = gc_adesc + " Main Menu"

        DO g_dspst WITH gc_task, ;
                        .f., ;
                        gn_msgline, ;
                        gc_applid, ;
                        gc_compid, ;
                        gc_userid

      ELSE
        gc_task = "System Manager Main Menu"

      ENDIF && lc_popup <> ".PCLS"

    ENDIF && NOT ll_ModalsOpen

    *-- Skip checking messages if called from clear temporary balances or 
    *-- close period options
    IF gc_mremind = "S" AND NOT ALLTRIM(UPPER(lc_popup)) $ ".CLRBAL.PCLS"
      *-- Check to see if there are phone messages
      *# DOCCODE DO symedt
      DO (gc_idrvprg + "symedt") WITH .t.
    ENDIF

    *-- Reattach help popup to main menu
    ON PAD gp_help OF _MSYSMENU ACTIVATE POPUP gu_help

  ENDIF && lc_popup <> ".EXIT" AND NOT EMPTY(lc_prg)

  IF NOT ALLTRIM(UPPER(lc_popup)) $ ".CLRBAL.PCLS.SYST" AND ;
     NOT ll_ModalsOpen
    *-- Enable toolbar
    DO g_dspbar WITH Cl_Enable
  ENDIF

  *-- Reenable menu pads
  gl_PadsOff = .f.

*\ PEPRG501 03 11/13/01 DLAH Correct cosmetic handling of initial menu setting
  *-- Refresh the menu
  ACTIVATE MENU _MSYSMENU NOWAIT

ENDIF

RETURN
*----------------------------------------------------------------------------
*- End Main: pe.prg
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_addfrx
*----------------------------------------------------------------------------
*- Synopsis...: Adds necessary entries to the Report Form Catalog table to
*-              support exporting reports to Excel.
*----------------------------------------------------------------------------
PROCEDURE l_addfrx

  *-- Declare local variables
  PRIVATE ln_alias, ;
          ln_opnfl

  *-- Initialize local variables
  ln_alias = SELECT()
  ln_opnfl = g_opnfl(gc_idrvdbf + "syrfrxs", ;
                     "a_syrfrx", ;
                     .f., ;
                     .f., ;
                     "frxname")

  *-- Update processing message
  DO g_dspst WITH "Checking Report Form Catalog", Cl_RefrText, gn_msgline, ;
                  "", "", ""

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEBMCF  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEBMCF", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEBMCF  ', " + ;
                                         "descript  WITH 'Configuration Listing by BOM Number', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEBMCI  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEBMCI", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEBMCI  ', " + ;
                                         "descript  WITH 'Configuration Listing by Parent Part', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEBMEC  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEBMEC", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEBMEC  ', " + ;
                                         "descript  WITH 'Exploded BOM with Costs', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEBMEX  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEBMEX", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEBMEX  ', " + ;
                                         "descript  WITH 'Exploded BOM without Costs', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEBMSC  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEBMSC", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEBMSC  ', " + ;
                                         "descript  WITH 'Summarized BOM with Costs', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEBMSM  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEBMSM", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEBMSM  ', " + ;
                                         "descript  WITH 'Summarized BOM without Costs', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEBMTL  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEBMTL", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEBMTL  ', " + ;
                                         "descript  WITH 'Top-Level BOM without costs', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PECLST  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PECLST", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PECLST  ', " + ;
                                         "descript  WITH 'Component Listing', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEITEM  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEITEM", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEITEM  ', " + ;
                                         "descript  WITH 'Finished Good Listing', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEJRLA  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEJRLA", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEJRLA  ', " + ;
                                         "descript  WITH 'Manufacturing Journal by Account', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEJRLD  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEJRLD", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEJRLD  ', " + ;
                                         "descript  WITH 'Manufacturing Journal by Date', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEJRLI  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEJRLI", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEJRLI  ', " + ;
                                         "descript  WITH 'Manufacturing Journal by Item', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEJRLL  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEJRLL", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEJRLL  ', " + ;
                                         "descript  WITH 'Manufacturing Journal by Location', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEJRLT  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEJRLT", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEJRLT  ', " + ;
                                         "descript  WITH 'Manufacturing Journal by Document', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEPLST  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEPLST", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEPLST  ', " + ;
                                         "descript  WITH 'Parent Listing', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEUNUS  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEUNUS", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEUNUS  ', " + ;
                                         "descript  WITH 'Unused Item Listing', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  IF NOT go_SQL.cmpA_Syrfrx.m_Seek("PEUSED  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating Report Form Catalog with PEUSED", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("frxname   WITH 'PEUSED  ', " + ;
                                         "descript  WITH 'Where Used Listing', " + ;
                                         "exportss  WITH gx_True, " + ;
                                         "subttype  WITH 'M', " + ;
                                         "asciicols WITH 0")
  ENDIF

  *-- Clear processing message
  DO g_dspst WITH Cc_NullStr, Cl_RefrText, gn_msgline, ;
                  "", "", ""

  IF ln_opnfl = 2 AND go_SQL.m_IsUsed("a_syrfrx")
    *-- Close file if opened here
    go_SQL.cmpA_Syrfrx.m_CloseTable()
  ENDIF

  *-- Return to inital work area
  go_SQL.m_TableChangeCurrent(ln_alias)

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_addfrx
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_addvcx
*----------------------------------------------------------------------------
*- Synopsis...: Adds necessary entries to the Customization Manager table to
*-              support customizing classes.
*----------------------------------------------------------------------------
PROCEDURE l_addvcx

  *-- Declare local variables
  PRIVATE ln_alias, ;
          ln_opnfl

  *-- Initialize local variables
  ln_alias = SELECT()
  ln_opnfl = g_opnfl(gc_idrvdbf + "syccmn", ;
                     "a_syccmn", ;
                     .f., ;
                     .f., ;
                     "sbtid")

  *-- Update processing message
  DO g_dspst WITH "Checking CU Class Library", Cl_RefrText, gn_msgline, ;
                  "", "", ""

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEBMCF  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEBMCF", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEBMCF  ', " + ;
                                         "sbtlib  WITH 'PEBMCF  ', " + ;
                                         "sbtname WITH 'PEBMCF  ', " + ;
                                         "descrip WITH 'Bill of Materials Configurator', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PECOMP  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PECOMP", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PECOMP  ', " + ;
                                         "sbtlib  WITH 'PECOMP  ', " + ;
                                         "sbtname WITH 'PECOMP  ', " + ;
                                         "descrip WITH 'Post Completed Manufacturing', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO2  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO2", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO2  ', " + ;
                                         "sbtlib  WITH 'PEFBO2  ', " + ;
                                         "sbtname WITH 'PEFBO2  ', " + ;
                                         "descrip WITH 'Bill of Materials Copy From', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO3  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO3", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO3  ', " + ;
                                         "sbtlib  WITH 'PEFBO3  ', " + ;
                                         "sbtname WITH 'PEFBO3  ', " + ;
                                         "descrip WITH 'Bill of Materials Notes', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO4  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO4", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO4  ', " + ;
                                         "sbtlib  WITH 'PEFBO4  ', " + ;
                                         "sbtname WITH 'PEFBO4  ', " + ;
                                         "descrip WITH 'Bill of Materials Components', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO5  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO5", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO5  ', " + ;
                                         "sbtlib  WITH 'PEFBO5  ', " + ;
                                         "sbtname WITH 'PEFBO5  ', " + ;
                                         "descrip WITH 'Bill of Materials Finished Goods', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO6  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO6", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO6  ', " + ;
                                         "sbtlib  WITH 'PEFBO6  ', " + ;
                                         "sbtname WITH 'PEFBO6  ', " + ;
                                         "descrip WITH 'Bill of Materials Component Detail', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO7  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO7", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO7  ', " + ;
                                         "sbtlib  WITH 'PEFBO7  ', " + ;
                                         "sbtname WITH 'PEFBO7  ', " + ;
                                         "descrip WITH 'Bill of Materials Finished Good Detail', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO8  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO8", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO8  ', " + ;
                                         "sbtlib  WITH 'PEFBO8  ', " + ;
                                         "sbtname WITH 'PEFBO8  ', " + ;
                                         "descrip WITH 'Bill of Materials Renumber', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBO9  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBO9", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBO9  ', " + ;
                                         "sbtlib  WITH 'PEFBO9  ', " + ;
                                         "sbtname WITH 'PEFBO9  ', " + ;
                                         "descrip WITH 'Bill of Materials FG Configurations', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEFBOM  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEFBOM", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEFBOM  ', " + ;
                                         "sbtlib  WITH 'PEFBOM  ', " + ;
                                         "sbtname WITH 'PEFBOM  ', " + ;
                                         "descrip WITH 'Bill of Materials Header', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEGTWO  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEGTWO", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEGTWO  ', " + ;
                                         "sbtlib  WITH 'PEGTWO  ', " + ;
                                         "sbtname WITH 'PEGTWO  ', " + ;
                                         "descrip WITH 'PE Transaction Number', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PEHKAS  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PEHKAS", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PEHKAS  ', " + ;
                                         "sbtlib  WITH 'PEHKAS  ', " + ;
                                         "sbtname WITH 'PEHKAS  ', " + ;
                                         "descrip WITH 'ATS HotKey', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PESYS2  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PESYS2", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PESYS2  ', " + ;
                                         "sbtlib  WITH 'PESYS2  ', " + ;
                                         "sbtname WITH 'PESYS2  ', " + ;
                                         "descrip WITH 'PE System Setup - Screen Labels', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PESYS3  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PESYS3", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PESYS3  ', " + ;
                                         "sbtlib  WITH 'PESYS3  ', " + ;
                                         "sbtname WITH 'PESYS3  ', " + ;
                                         "descrip WITH 'PE System Setup - Link Settings', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PESYS4  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PESYS4", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PESYS4  ', " + ;
                                         "sbtlib  WITH 'PESYS4  ', " + ;
                                         "sbtname WITH 'PESYS4  ', " + ;
                                         "descrip WITH 'PE System Setup - System Options', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  IF NOT go_SQL.cmpA_Syccmn.m_Seek("PESYST  ", "")
    *-- Update processing message
    DO g_dspst WITH "Updating CU Class Library with PESYST", Cl_RefrText, gn_msgline, ;
                    "", "", ""

    *-- Add new record
    go_SQL.so_CurrentAlias.m_Add()
    go_SQL.so_CurrentAlias.m_ReplaceBulk("applid  WITH 'PE', " + ;
                                         "sbtid   WITH 'PESYST  ', " + ;
                                         "sbtlib  WITH 'PESYST  ', " + ;
                                         "sbtname WITH 'PESYST  ', " + ;
                                         "descrip WITH 'PE System Setup - System Settings', " + ;
                                         "cstmize WITH gx_True, " + ;
                                         "adduser WITH 'ADMN', " + ;
                                         "adddate WITH {07/27/2001}, " + ;
                                         "addtime WITH '05:00:00'")
  ENDIF

  *-- Clear processing message
  DO g_dspst WITH Cc_NullStr, Cl_RefrText, gn_msgline, ;
                  "", "", ""

  IF ln_opnfl = 2 AND go_SQL.m_IsUsed("a_syccmn")
    *-- Close file if opened here
    go_SQL.cmpA_Syccmn.m_CloseTable()
  ENDIF

  *-- Return to inital work area
  go_SQL.m_TableChangeCurrent(ln_alias)

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_addvcx
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_dfmpe
*----------------------------------------------------------------------------
*- Synopsis...: Define subsidiary pulldowns for this application.
*----------------------------------------------------------------------------
*- Calls......: pemain.mpr
*----------------------------------------------------------------------------
*- Passed:
*- Variables..: gc_peprgdv
*----------------------------------------------------------------------------
PROCEDURE l_dfmpe

  DO (gc_peprgdv + "pemain.mpr")

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_dfmpe
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_rlspe
*----------------------------------------------------------------------------
*- Synopsis...: Cleanup on exit from application.  Releases all global
*-              variables and popup menus defined for this application.
*----------------------------------------------------------------------------
*- Calls......: icproc.prg
*----------------------------------------------------------------------------
*- Passed:
*- Variables..: None
*-
*- Parameters.: <ExpC>   pc_popup,   name of popup menu, if defined.
*----------------------------------------------------------------------------
*- Returns:
*- Variables..: gc_applid, gc_adesc
*-
*- Files Open.: Closes all open files
*----------------------------------------------------------------------------
PROCEDURE l_rlspe

PARAMETERS pc_popup

  *-- Delcare local variables
  PRIVATE lc_popup

  *-- Initialize local variables
  lc_popup = IIF(TYPE("pc_popup") = "L", ;
                 SPACE(0), ;
                 pc_popup)

  *-- Release global PE path variables
  RELEASE gc_pedbfdr, ;
          gc_pendxdr, ;
          gc_peprgdv

*\ [1 Line] PTR# 74151 04/21/04 KGUP Added gl_UseBOMcompUOM
  *-- Release global PE memory variables
  RELEASE gc_babbr, ;
          gc_bname, ;
          gc_cname, ;
          gc_cnames, ;
          gc_deflink, ;
          gc_fname, ;
          gc_fnames, ;
          gc_link, ;
          gc_method, ;
          gc_pname, ;
          gc_taxpict, ;
          gc_vname, ;
          gc_vnames, ;
          gl_expsor, ;
          gl_fnloct, ;
          gl_gllink, ;
          gl_icsumm, ;
          gl_nosrlc, ;
          gl_solink, ;
          gl_srchsb, ;
          gn_bomline, ;
          gn_incrmnt, ;
          gn_maxlevl, ;
          gl_UseBOMcompUOM
          
  *-- Release global GL memory variables
  RELEASE gc_acctpic, ;
          gc_aract, ;
          gc_cshact, ;
          gc_discact, ;
          gc_fchgact, ;
          gc_sltxact, ;
          gf_glacntf, ;
          gf_glsegsf, ;
          gf_gltypef

  *-- If IC installed for this company
  IF gn_ic > 1
    *-- Call procedure for release of IC2 configuration variables
    DO (gc_icprgdv + "icproc") WITH ".RLS", ""
  ENDIF

  IF gl_ap OR gl_po
    *-- Release AP filenames
    RELEASE gf_apmastf, ;
            gf_apvendf, ;
            gf_apvhstf, ;
            gf_apymstf

  ENDIF

  IF gl_ar OR gl_so
    *-- Release AR/SO filenames
    RELEASE gf_arcadrf, ;
            gf_archstf, ;
            gf_arcustf, ;
            gf_artxcrf

  ENDIF

  IF gl_ar
    *-- Release AR filenames
    RELEASE gf_arcashf, ;
            gf_arglacf, ;
            gf_armastf, ;
            gf_artranf, ;
            gf_arycshf, ;
            gf_arymstf, ;
            gf_arytrnf

  ENDIF

  IF gl_po
    *-- Release PO filenames
    RELEASE gf_pomastf, ;
            gf_potranf, ;
            gf_poymstf, ;
            gf_poytrnf

  ENDIF

  IF gl_so
    *-- Release SO filenames public
    RELEASE gf_somastf, ;
            gf_soslsmf, ;
            gf_sotranf, ;
            gf_soymstf

  ENDIF
  
*-- HOOK BEGIN: <ACS>: Call program to setup UPOS variables
  IF gl_acs
    DO (gc_idrvdbf + "pe\pea.prg") WITH "1"
  ENDIF

*-- HOOK END: <ACS>: Call program to setup UPOS variables

  *-- Release PE specific variables only
  DO l_rlspely WITH lc_popup

  IF lc_popup <> ".PCLS"
    *-- Release pulldowns
    RELEASE POPUPS gu_tran, ;
                   gu_mant, ;
                   gu_mant1, ;
                   gu_prnt

    *-- Menu handling when returning from Custom app
    PRIVATE ln_count

    *-- Detach pulldowns from pads on main menu
    FOR ln_count = 1 TO CNTPAD("_MSYSMENU")

      *-- Check to see if PAD is defined before releasing pulldowns
      DO CASE
        CASE PRMPAD("_MSYSMENU", GETPAD("_MSYSMENU", ln_count)) = "Transaction"
          ON PAD gp_tran OF _MSYSMENU
        CASE PRMPAD("_MSYSMENU", GETPAD("_MSYSMENU", ln_count)) = "Maintain"
          ON PAD gp_mant OF _MSYSMENU
        CASE PRMPAD("_MSYSMENU", GETPAD("_MSYSMENU", ln_count)) = "Print"
          ON PAD gp_prnt OF _MSYSMENU
      ENDCASE

    NEXT

  ENDIF

  *-- Reset global application variables
  gc_applid = "  "
  gc_adesc  = ""

  *-- Close open files
  go_Sql.m_CloseTableAll()

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_rlspe
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_rlspely
*----------------------------------------------------------------------------
*- Synopsis...: Release PE specific variables.
*----------------------------------------------------------------------------
*- Passed:
*- Parameters.: <ExpC>   pc_popup,   name of popup menu, if defined.
*----------------------------------------------------------------------------
PROCEDURE l_rlspely

PARAMETERS pc_popup

  *-- Delcare local variables
  PRIVATE lc_popup, ;
          ln_wrkarea, ;
          ln_hiarea

  *-- Initialize local variables
  lc_popup   = IIF(TYPE("pc_popup") = "L", ;
                   SPACE(0), ;
                   pc_popup)
  ln_hiarea  = 1
  ln_wrkarea = 1

  *-- Determine the highest work area
  go_SQL.m_TableChangeCurrent(0)
  ln_hiarea = MAX(SELECT(),75)

  *-- Release global PE path variables
  RELEASE gc_pedbfdr, ;
          gc_pendxdr, ;
          gc_peprgdv

*\ [1 Line] PTR 74151 04/21/04 KGUP Added gl_UseBOMcompUOM
 *-- Release global PE memory variables
  RELEASE gc_babbr, ;
          gc_bname, ;
          gc_cname, ;
          gc_cnames, ;
          gc_deflink, ;
          gc_fname, ;
          gc_fnames, ;
          gc_link, ;
          gc_method, ;
          gc_pname, ;
          gc_pnames, ;
          gc_taxpict, ;
          gc_vname, ;
          gc_vnames, ;
          gl_expsor, ;
          gl_fnloct, ;
          gl_gllink, ;
          gl_icsumm, ;
          gl_nosrlc, ;
          gl_solink, ;
          gl_srchsb, ;
          gn_bomline, ;
          gn_incrmnt, ;
          gn_maxlevl, ;
          gl_UseBOMcompUOM

  *-- Release global PE filenames
  RELEASE gf_pebmcff, ;
          gf_pebmdtf, ;
          gf_pebmhdf, ;
          gf_pebmitf, ;
          gf_pemastf, ;
          gf_petranf, ;
          gf_peybmdf, ;
          gf_peybmhf, ;
          gf_peybmif

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_rlspely
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_varpe
*----------------------------------------------------------------------------
*- Synopsis...: Define application-specific global variables.
*----------------------------------------------------------------------------
*- Calls......: d_setap(),  d_setfl(),  g_dspalt,   g_opnfl(),  g_setary(), 
*-              g_setsys(), icproc.prg
*----------------------------------------------------------------------------
*- Passed:
*- Variables..: gc_applid, gc_compid
*-
*- Files Open.: Opens SYCDATA, SYCPATH, and SYSDATA if not already open.
*----------------------------------------------------------------------------
*- Returns:
*- Variables..: Many
*-
*- Files Open.: Leaves SYCDATA, SYCPATH, and SYSDATA open.
*----------------------------------------------------------------------------
PROCEDURE l_varpe

  *-- Declare local variables
  PRIVATE ln_pesys

  *-- Open installed applications file
  = g_opnfl(gc_idrvdbf + "sycdata", ;
            "a_sycdat", ;
            .f., ;
            .f., ;
            "compid1")

  *-- Set filter
  go_SQL.so_CurrentAlias.m_SetFilter("NOT EMPTY(compid + applid) AND " + ;
                                     "NOT DELETED()")

  *-- Open custom path file
  = g_opnfl(gc_idrvdbf + "sycpath", ;
            "a_sycpat", ;
            .f., ;
            .f., ;
            "compid1")

  *-- Set filter
  go_SQL.so_CurrentAlias.m_SetFilter("NOT EMPTY(compid + tablid) AND " + ;
                                     "NOT DELETED()")

  *-- Position on sysdata record for current company/application
  ln_pesys = g_setsys(gc_applid, gc_compid, .f.)

  *-- Setup global PE path variables
  RELEASE gc_pedbfdr, ;
          gc_pendxdr, ;
          gc_peprgdv

  PUBLIC  gc_pedbfdr, ;
          gc_pendxdr, ;
          gc_peprgdv

*\ [1 Line] PTR# 74151 04/21/04 KGUP Added variable gl_UseBOMcompUOM
  *-- Setup global PE memory variables
  RELEASE gc_babbr, ;
          gc_bname, ;
          gc_cname, ;
          gc_cnames, ;
          gc_deflink, ;
          gc_fname, ;
          gc_fnames, ;
          gc_link, ;
          gc_method, ;
          gc_pname, ;
          gc_pnames, ;
          gc_taxpict, ;
          gc_vname, ;
          gc_vnames, ;
          gl_expsor, ;
          gl_fnloct, ;
          gl_gllink, ;
          gl_icsumm, ;
          gl_nosrlc, ;
          gl_solink, ;
          gl_srchsb, ;
          gn_bomline, ;
          gn_incrmnt, ;
          gn_maxlevl, ;
          gl_UseBOMcompUOM

*\ [1 Line] PTR# 74151 04/21/04 KGUP Added variable gl_UseBOMcompUOM
  PUBLIC  gc_babbr, ;
          gc_bname, ;
          gc_cname, ;
          gc_cnames, ;
          gc_deflink, ;
          gc_fname, ;
          gc_fnames, ;
          gc_link, ;
          gc_method, ;
          gc_pname, ;
          gc_pnames, ;
          gc_taxpict, ;
          gc_vname, ;
          gc_vnames, ;
          gl_expsor, ;
          gl_fnloct, ;
          gl_gllink, ;
          gl_icsumm, ;
          gl_nosrlc, ;
          gl_solink, ;
          gl_srchsb, ;
          gn_bomline, ;
          gn_incrmnt, ;
          gn_maxlevl, ;
          gl_UseBOMcompUOM

  *-- Setup global GL memory variables
  RELEASE gc_acctpic, ;
          gc_aract, ;
          gc_cshact, ;
          gc_discact, ;
          gc_fchgact, ;
          gc_sltxact

  PUBLIC  gc_acctpic, ;
          gc_aract, ;
          gc_cshact, ;
          gc_discact, ;
          gc_fchgact, ;
          gc_sltxact

  *-- Setup global PE filenames
  RELEASE gf_glacntf, ;
          gf_glsegsf, ;
          gf_gltypef, ;
          gf_icitemf, ;
          gf_icsuplf, ;
          gf_ictranf, ;
          gf_icytrnf, ;
          gf_pebmcff, ;
          gf_pebmdtf, ;
          gf_pebmhdf, ;
          gf_pebmitf, ;
          gf_pemastf, ;
          gf_petranf, ;
          gf_peybmdf, ;
          gf_peybmhf, ;
          gf_peybmif
    
  PUBLIC  gf_glacntf, ;
          gf_glsegsf, ;
          gf_gltypef, ;
          gf_icitemf, ;
          gf_icsuplf, ;
          gf_ictranf, ;
          gf_icytrnf, ;
          gf_pebmcff, ;
          gf_pebmdtf, ;
          gf_pebmhdf, ;
          gf_pebmitf, ;
          gf_pemastf, ;
          gf_petranf, ;
          gf_peybmdf, ;
          gf_peybmhf, ;
          gf_peybmif
     
  IF gn_ic > 1
    RELEASE gf_iccostf, ;
            gf_iccyctf, ;
            gf_icdistf, ;
            gf_ichistf, ;
            gf_icilocf, ;
            gf_icilotf, ;
            gf_iciqtyf, ;
            gf_icitemf, ;
            gf_icloctf, ;
            gf_icpgrpf, ;
            gf_icplinf, ;
            gf_icpricf, ;
            gf_icsuplf, ;
            gf_ictranf, ;
            gf_icunmsf, ;
            gf_icydstf, ;
            gf_icysnof, ;
            gf_icytrnf
            
    PUBLIC  gf_iccostf, ;
            gf_iccyctf, ;
            gf_icdistf, ;
            gf_ichistf, ;
            gf_icilocf, ;
            gf_icilotf, ;
            gf_iciqtyf, ;
            gf_icitemf, ;
            gf_icloctf, ;
            gf_icpgrpf, ;
            gf_icplinf, ;
            gf_icpricf, ;
            gf_icsuplf, ;
            gf_ictranf, ;
            gf_icunmsf, ;
            gf_icydstf, ;
            gf_icysnof, ;
            gf_icytrnf

  ENDIF && gn_ic > 1

  *-- Open SYSDATA file and position on IC Record for current company
  go_SQL.m_SQLSelect("* FROM " + go_SQL.sc_SysDbName + ;
                      "sysdata WHERE sysid = 'IC" + gc_CompId + "'" + ;
                      " AND LEFT(pass2, 1) <> 'D'", "CURSOR", "ac_SysDataIC")

  *-- Open SYSDATA file and position on record for current PE company
  ln_pesys = g_setsys(gc_applid, gc_compid, .f.)

  *-- Verify GL link in IC vs. PE
  DO CASE
    CASE (LEFT(ac_SysDataIC->link, 1) = "Y") = .t. AND ;
         (LEFT(a_sysdat->link, 1) = "Y") = .f.

      gl_gllink = .t.

*\ [1 line] PTR# 71824 BAUG 01/28/04 Expand company ID to 10 characters 
      gc_link   = ac_SysDataIC->gllinkco

    CASE (LEFT(ac_SysDataIC->link, 1) = "Y") = .f. AND ;
         (LEFT(a_sysdat->link, 1) = "Y") = .t.

      gl_gllink = .f.

    OTHERWISE
      *-- Use GL link in PE as defined
      gl_gllink = (LEFT(a_Sysdat->link, 1) = "Y")

*\ [1 line] PTR# 71824 BAUG 01/28/04 Expand company ID to 10 characters 
      gc_link   = a_Sysdat->gllinkco

  ENDCASE

  *-- Application-specific variables
  gl_solink  = (SUBSTR(a_sysdat->link, 5, 1) = "Y")
  gc_method  = IIF(SUBSTR(a_sysdat->link, 7, 1) = "B", "Bottom", ;
                 IIF(SUBSTR(a_sysdat->link, 7, 1) = "S", "Smart ", "Top   "))
  gl_fnloct  = (SUBSTR(a_sysdat->link, 9, 1) = "Y")
  gl_expsor  = (SUBSTR(a_sysdat->link, 10, 1) = "Y")
  gl_srchbd  = (SUBSTR(a_sysdat->link, 11, 1) = "Y")
  gl_nosrlc  = (SUBSTR(a_sysdat->link, 13, 1) = "Y")
  gc_deflink = IIF(SUBSTR(a_sysdat->link, 40, 6) = SPACE(6), ;
                   "DEFDEF", ;
                   SUBSTR(a_sysdat->link, 40, 6))
  gc_bname   = IIF(SUBSTR(a_sysdat->str1, 1, 20) = SPACE(20), ;
                   "Bill of Materials", ;
                   ALLTRIM(SUBSTR(a_sysdat->str1, 1, 20)))
  gc_cname   = IIF(SUBSTR(a_sysdat->str1, 21, 15) = SPACE(15), ;
                   "Component", ;
                   ALLTRIM(SUBSTR(a_sysdat->str1, 21, 15)))
  gc_fname   = IIF(SUBSTR(a_sysdat->str1, 36, 15) = SPACE(15), ;
                   "Finished Good", ;
                   ALLTRIM(SUBSTR(a_sysdat->str1, 36, 15)))
  gc_vname   = IIF(SUBSTR(a_sysdat->str1, 51, 15) = SPACE(15), ;
                  "Revision Level", ;
                  ALLTRIM(SUBSTR(a_sysdat->str1, 51, 15)))
  gc_pname   = IIF(SUBSTR(a_sysdat->str2, 1, 20) = SPACE(20), ;
                   "Bills of Materials", ;
                   ALLTRIM(SUBSTR(a_sysdat->str2, 1, 20)))
  gc_cnames  = IIF(SUBSTR(a_sysdat->str2, 21, 15) = SPACE(15), ;
                   "Components", ;
                   ALLTRIM(SUBSTR(a_sysdat->str2, 21, 15)))
  gc_fnames  = IIF(SUBSTR(a_sysdat->str2, 36, 15) = SPACE(15), ;
                   "Finished Goods", ;
                   ALLTRIM(SUBSTR(a_sysdat->str2, 36, 15)))
  gc_vnames  = IIF(SUBSTR(a_sysdat->str2, 51, 15) = SPACE(15), ;
                   "Revision Levels", ;
                   ALLTRIM(SUBSTR(a_sysdat->str2, 51, 15)))
  gc_babbr   = IIF(SUBSTR(a_sysdat->str7, 1, 3) = SPACE(3), ;
                   "BOM", ;
                   ALLTRIM(SUBSTR(a_sysdat->str7, 1, 3)))
  gn_maxlevl = IIF(gl_laheypl, ;
                   1, ;
                   IIF(VAL(SUBSTR(a_sysdat->str7, 14, 3)) = 0, ;
                       99, ;
                       VAL(SUBSTR(a_sysdat->str7, 14, 3))))
  gl_icsumm  = (SUBSTR(a_sysdat->str7, 17, 1) = "Y")
  gl_srchsb  = (SUBSTR(a_sysdat->link, 11, 1) = "Y")
  gn_bomline = IIF(VAL(SUBSTR(a_sysdat->str7, 19, 3)) = 0, ;
                   10, ;
                   VAL(SUBSTR(a_sysdat->str7, 19, 3)))
  gn_incrmnt = IIF(VAL(SUBSTR(a_sysdat->str7, 22, 3)) = 0, ;
                   10, ;
                   VAL(SUBSTR(a_sysdat->str7, 22, 3)))

  *-- Picture for item tax code field
  gc_taxpict = IIF(gl_lntax, ;
                   "@A!", ;
                   "Y")

  *-- Callout to setup account arrays
  DO g_setary WITH IIF(gl_gllink, ;
                       (gc_link), ;
                       "")

  *-- Find installed application record
  go_SQL.m_TableChangeCurrent("a_sycdat")
  go_SQL.cmpA_Sycdat.m_SetOrder("compid1")
  go_SQL.so_CurrentAlias.m_Seek(gc_compid + gc_applid, "")

  *-- Application file locations
  *-- Application data path
  gc_pedbfdr  = ALLTRIM(a_sycdat->adosdbf)
  *-- Application index path
  gc_pendxdr  = ALLTRIM(a_sycdat->adosndx)
  *-- Application program path
  gc_adrvprg  = ALLTRIM(a_sycdat->adosprg)
  gc_peprgdv  = ALLTRIM(a_sycdat->adosprg)

  *-- Current application version
  gc_versn   = d_retap(gc_applid, 2)

  *-- Use rule tables?
  gl_chkrule = (a_sycdat->chkrule = gx_true)

  *-- Confirm entries?
  gl_confrme = (a_sycdat->confrme = gx_true)

  *-- Confirm selection?
  gl_confrms = (a_sycdat->confrms = gx_true)

  *-- If IC installed for this company
  IF gn_ic > 1

*\ [1 Line] PTR# 76523 07/29/04 TISN Determine component UOM usage setting
*\ [Begin] PTR# 74151 04/21/04 KGUP Determine component UOM usage setting from IC record
    gl_UseBOMcompUOM = (SUBSTR(a_sysdat->str3, 1, 1) = "Y")
*\ [End] PTR# 74151 04/21/04 KGUP Determine component UOM usage setting from IC record

    *-- Search for IC record in SYCDATA
    go_SQL.m_TableChangeCurrent("a_sycdat")
    go_SQL.so_CurrentAlias.m_Seek(gc_compid + "IC", "")

    *-- If found
    IF go_SQL.so_CurrentAlias.m_IsFound()
      *-- Setup variables for IC file locations
      RELEASE gc_icdbfdr, ;
              gc_icndxdr
      PUBLIC  gc_icdbfdr, ;
              gc_icndxdr

      *-- IC Application data file locations
      gc_icdbfdr = ALLTRIM(a_sycdat->adosdbf)
      gc_icndxdr = ALLTRIM(a_sycdat->adosndx)

    ENDIF

    *-- Reset record pointer in SYCDATA to PE
    go_SQL.so_CurrentAlias.m_Seek(gc_compid + gc_applid, "")

  ENDIF && gn_ic > 1

  IF gl_ar OR gl_so
    RELEASE gc_slsclc, ;
            gl_slsclc
    PUBLIC  gc_slsclc, ;
            gl_slsclc

    *-- Setup for SO link
    = g_setsys("SO", gc_compid, .f.)

    *-- If SO company found
    IF go_SQL.so_CurrentAlias.m_IsFound()
      *-- Read track sales commissions link field
      gc_slsclc = IIF(SUBSTR(a_sysdat->link, 5, 1) = SPACE(1), ;
                      "N", ;
                      SUBSTR(a_sysdat->link, 5, 1))
      gl_slsclc = (SUBSTR(a_sysdat->link, 5, 1) = "Y")
    ELSE
      gc_slsclc = "N"
      gl_slsclc = .f.
    ENDIF

    *-- Return to PE record
    go_SQL.cmpA_Sysdat.m_MoveToRecno(ln_pesys)

  ENDIF && gl_ar OR gl_so

  *-- Setup file location for GL link
  IF gl_gllink
    go_SQL.m_TableChangeCurrent("a_sycdat")
    go_SQL.so_CurrentAlias.m_Seek(gc_link + "GL", "")

    *-- If GL company found
    IF go_SQL.so_CurrentAlias.m_IsFound()
      RELEASE gc_gldbfdr
      PUBLIC  gc_gldbfdr

      *-- GL Application data file locations for GL transfers
      gc_gldbfdr = ALLTRIM(a_sycdat->adosdbf)

    ENDIF

    *-- Reset record pointer in SYCDATA
    go_SQL.m_TableChangeCurrent("a_sycdat")
    go_SQL.so_CurrentAlias.m_Seek(gc_compid + gc_applid, "")

    *-- Setup for AR link
    = g_setsys("AR", gc_compid, .f.)

    *-- If AR company found
    IF go_SQL.so_CurrentAlias.m_IsFound()
      *-- read default AR accounts from link field
      gc_cshact  = TRANSFORM(SUBSTR(a_sysdat->link, 46, 24), gc_acctpic)
      gc_aract   = TRANSFORM(SUBSTR(a_sysdat->link, 71, 24), gc_acctpic)
      gc_sltxact = TRANSFORM(SUBSTR(a_sysdat->link, 96, 24), gc_acctpic)
      gc_fchgact = TRANSFORM(SUBSTR(a_sysdat->link,121, 24), gc_acctpic)
      gc_discact = TRANSFORM(SUBSTR(a_sysdat->link,146, 24), gc_acctpic)

    ENDIF

    *-- Return to PE record
    go_SQL.cmpA_Sysdat.m_MoveToRecno(ln_pesys)

  ENDIF && gl_gllink

  IF gl_ap OR gl_po
    *-- Setup AP/PO filenames
    RELEASE gf_apvendf, ;
            gf_apvhstf
    PUBLIC  gf_apvendf, ;
            gf_apvhstf

  ENDIF

  IF gl_ar OR gl_so
    *-- Setup AR/SO filenames
    RELEASE gf_arcadrf, ;
            gf_archstf, ;
            gf_arcustf, ;
            gf_artxcrf
    PUBLIC  gf_arcadrf, ;
            gf_archstf, ;
            gf_arcustf, ;
            gf_artxcrf

  ENDIF

  IF gl_ar
    *-- Setup AR filenames
    RELEASE gf_arcashf, ;
            gf_arglacf, ;
            gf_armastf, ;
            gf_artranf, ;
            gf_arycshf, ;
            gf_arymstf, ;
            gf_arytrnf

    PUBLIC  gf_arcashf, ;
            gf_arglacf, ;
            gf_armastf, ;
            gf_artranf, ;
            gf_arycshf, ;
            gf_arymstf, ;
            gf_arytrnf

  ENDIF

  IF gl_po
    *-- Setup PO filenames
    RELEASE gf_pomastf, ;
            gf_potranf, ;
            gf_poymstf, ;
            gf_poytrnf

    PUBLIC  gf_pomastf, ;
            gf_potranf, ;
            gf_poymstf, ;
            gf_poytrnf

  ENDIF

  IF gl_so
    *-- Setup SO filenames public
    RELEASE gf_somastf, ;
            gf_soslsmf, ;
            gf_sotranf, ;
            gf_soymstf

    PUBLIC  gf_somastf, ;
            gf_soslsmf, ;
            gf_sotranf, ;
            gf_soymstf

  ENDIF

*-- HOOK BEGIN: <ACS>: Call program to setup UPOS variables
  IF gl_acs
    DO (gc_idrvdbf + "pe\pea.prg") WITH "2"
  ENDIF

*-- HOOK END: <ACS>: Call program to setup UPOS variables

  *-- Check for saved file variable memory file
  *-- Variable MEM file locations
  RELEASE gf_fvarmem
  PUBLIC  gf_fvarmem

*\ [1 line] PTR# 71824 BAUG 01/28/04 Expand company ID to 10 characters 
  gf_fvarmem = gc_idrvdbf + gc_applid + "FDOS" + ALLTRIM(gc_compid) + ".MEM"

  *-- Check for saved file variable memory file
  IF FILE(gf_fvarmem)
    *-- Restore variables from memory file
    RESTORE FROM (gf_fvarmem) ADDITIVE

  ELSE
    *-- If saved memory file not found, setup file name variables
    = d_setap(gc_applid, ;
              gc_compid, ;
              gc_pedbfdr, ;
              gc_pendxdr, ;
              1, ;
              .t.)

    *-- If IC installed for this company
    IF gn_ic > 1
      *-- Set up all IC file names if IC is installed
      = d_setap("IC", ;
                gc_compid, ;
                gc_icdbfdr, ;
                gc_icndxdr, ;
                1, ;
                .t.)
    ENDIF

    *-- If AP or PO installed for this company
    IF gl_ap OR gl_po
      *-- Get file variables for vendor files from dictionary
      = d_setfl("APVEND", gc_compid, 1)
      = d_setfl("APVHST", gc_compid, 1)
    ENDIF

    *-- If AR or SO installed for this company
    IF gl_ar OR gl_so
      *-- Get file variables for customer files from dictionary
      = d_setfl("ARCADR", gc_compid, 1)
      = d_setfl("ARCUST", gc_compid, 1)
      = d_setfl("ARCHST", gc_compid, 1)
      = d_setfl("ARTXCR", gc_compid, 1)
    ENDIF

    IF gl_ar
      *-- Get ARTRAN filenames
      = d_setfl("ARCASH", gc_compid, 1)
      = d_setfl("ARGLAC", gc_compid, 1)
      = d_setfl("ARMAST", gc_compid, 1)
      = d_setfl("ARTRAN", gc_compid, 1)
      = d_setfl("ARYCSH", gc_compid, 1)
      = d_setfl("ARYMST", gc_compid, 1)
      = d_setfl("ARYTRN", gc_compid, 1)
    ENDIF

    IF gl_so
      *-- Get SO filenames
      = d_setfl("SOMAST", gc_compid, 1)
      = d_setfl("SOSLSM", gc_compid, 1)
      = d_setfl("SOTRAN", gc_compid, 1)
      = d_setfl("SOYMST", gc_compid, 1)
    ENDIF

    IF gl_po
      *-- Get PO filenames
      = d_setfl("POMAST", gc_compid, 1)
      = d_setfl("POTRAN", gc_compid, 1)
      = d_setfl("POYMST", gc_compid, 1)
      = d_setfl("POYTRN", gc_compid, 1)
    ENDIF

    *-- Save to memory file
    SAVE TO (gf_fvarmem) ALL LIKE gf_*

  ENDIF && FILE(gf_fvarmem)

  *-- If linked to GL, find installation record and initialize gf_glacntf/x
  *-- with appropriate company number
  IF gl_gllink
    go_SQL.m_TableChangeCurrent("a_sycdat")
    go_SQL.so_CurrentAlias.m_Seek(gc_link + "GL", "")

    *-- If not found
    IF NOT go_SQL.so_CurrentAlias.m_IsFound()
      *-- If no GL record undo link to GL
*\ PEPRG502 02 01/12/02 DLAH Correct error 107 when GL not installed
      DO g_dspalt WITH "No record of installed GL application for " + ;
                       gc_oseol + "linked company " + gc_link + ".", 2

      *-- Cancel link
      gl_gllink = .f.

    ELSE
      *-- If found
      = d_setfl("GLACNT", gc_link, 1)
      = d_setfl("GLSEGS", gc_link, 1)
      = d_setfl("GLTYPE", gc_link, 1)

    ENDIF

  ENDIF && gl_gllink

  *-- If IC installed for this company
  IF gn_ic > 1
    *-- Call procedure for setup of IC2 configuration variables
    DO (gc_icprgdv + "icproc") WITH ".INIT", ""
  ENDIF

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_varpe
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_pepcls
*----------------------------------------------------------------------------
*- Synopsis...: Handler for PE period/year close
*----------------------------------------------------------------------------
*- Calls......: c_setap, l_rlspe, l_varpe, pepcls.prg
*----------------------------------------------------------------------------
*- Parameters.: <ExpC>   pc_period,  "P" indicates that the user chose 
*-                                   Close Period from the SM menu.
*-                                   "Y" indicates that the user chose 
*-                                   Close Period and Year from the SM menu.
*----------------------------------------------------------------------------
PROCEDURE l_pepcls

PARAMETERS pc_period

  *-- Initialize general application globals
  DO c_setap

  *-- Initialize PE application specific global variables
  DO l_varpe

  *-- Setup process ID for period closing
  gc_procid = "PEPCLS01"
  ll_dspwk  = .t.

  *-- Call period/year closing routine
  DO (gc_adrvprg + "pepcls") WITH pc_period

  *-- Release PE application specific global variables
  DO l_rlspe WITH ".PCLS"

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_pepcls
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_updbit
*----------------------------------------------------------------------------
*- Synopsis...: Seeks in BOM detail file to determine if item is a
*-              component on any bill of material.  It then sets ONBOM
*-              field based on whether it found the item.
*----------------------------------------------------------------------------
*- Calls......: g_lckrc()
*----------------------------------------------------------------------------
*- Passed:
*- Parameters.: <ExpC>  pc_item,    Item to check for
*-
*- Files Open.: PEBMDT, BOM detail file
*----------------------------------------------------------------------------
*- Returns:
*- Files Open.: PEBMDT, BOM detail file
*----------------------------------------------------------------------------
*- Example:
*-   DO l_updbit
*----------------------------------------------------------------------------
PROCEDURE l_updbit

PARAMETERS pc_item

  *-- Store ALIAS record number and order for reset after use check
  lc_xalias = ALIAS()
  ln_cdrec  = go_SQL.cmpA_Pebmdt.m_GetRecno()
  lc_cdtag  = go_SQL.cmpA_Pebmdt.m_GetOrder()
  lc_cditm  = a_pebmdt->item

  *-- Set to order by item and check for item built by any BOM
  go_SQL.m_TableChangeCurrent("a_pebmdt")
  go_SQL.cmpA_Pebmdt.m_SetOrder(0)

  *-- Determine if item is currently on a BOM
  go_SQL.so_CurrentAlias.m_Locate("FOR a_pebmdt->item = '" + pc_item + ;
                                  "' AND NOT DELETED()")

  *-- Find item record in item master
  go_SQL.m_TableChangeCurrent("a_icitem")
  go_SQL.cmpA_Icitem.m_SetOrder("item")
  go_SQL.so_CurrentAlias.m_Seek(pc_item, "")

  *-- If item is marked on BOM but isn't or marked as not on BOM but is
  IF go_SQL.so_CurrentAlias.m_IsFound() AND ;
    ((onbom = gx_true AND go_SQL.cmpA_Pebmdt.m_IsEof()) OR ;
    (NOT (onbom = gx_true) AND NOT go_SQL.cmpA_Pebmdt.m_IsEof())) AND ;
    (go_SQL.so_CurrentAlias.m_LockRow(gn_retry, .t.))
    go_SQL.so_CurrentAlias.m_ReplaceBulk("onbom   WITH IIF(go_SQL.cmpA_Pebmdt.m_IsEof(), gx_false, gx_true), " + ;
                                         "lckuser WITH gc_userid, " + ;
                                         "lckdate WITH DATE(), " + ;
                                         "lcktime WITH TIME()")
    go_SQL.so_CurrentAlias.m_Unlock()

  ENDIF

  IF NOT EMPTY(lc_xalias)
    go_SQL.m_TableChangeCurrent(lc_xalias)
  ELSE
    go_SQL.m_TableChangeCurrent("a_pebmdt")
  ENDIF

  *-- Reset tag and record pointer
  go_SQL.cmpA_Pebmdt.m_SetOrder(lc_cdtag)
  go_SQL.cmpA_Pebmdt.m_MoveToRecno(ln_cdrec)

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_updbit
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Procedure..: l_expbom
*----------------------------------------------------------------------------
*- Synopsis...: Explode BOM detail for reporting.
*----------------------------------------------------------------------------
*- Calls......: g_dspst()
*----------------------------------------------------------------------------
*- Passed:
*- Variables..: gc_extdbf, gc_idrvtmp, gc_tmpf1, gc_tmpf2, gn_msgline,
*-              ll_cont
*-
*- Parameters.: <ExpN>   ln_mult,    multiplication factor for qtys
*-              <ExpN>   ln_maxlev,  maximum number of levels to explode
*-              <ExpC>   lc_bomno,   BOM number to explode
*-              <ExpC>   lc_revlev,  revision level of BOM to explode
*-              <ExpC>   lc_cstmeth, costing method, one of:
*-                                   "W" = weighted average cost 
*-                                         from a_icitem->avgcost
*-                                   "S" = standard cost 
*-                                         from a_icitem->stdcost  
*-                                   "L" = last cost
*-                                         from a_icitem->lstcost
*-              <ExpC>   pc_cstloc,  costing location
*-
*- Files Open.: Assumes ICITEM, ICILOC, PEBMDT, and PEBMHD are open and that
*-              temporary file with BOM headers to be processed is open
*-              as a_tmpf1.  Assumes temporary detail file (a_tmpf2) has
*-              been created with structure of:
*-
*-  Field    Type     Description
*-  -------- -------- ----------------------------------------
*-  LEVEL    C(12)    String level indicator
*-  BOMNO    C(15)    BOM Number for top level
*-  REVLEV   C(15)    Revision level for top level
*-  ITEM     C(15)    Item number (finished good if top level)
*-  REVBOM   C(15)    BOM revision level required for detail
*-  LOCTID   C(6)     Item location
*-  STORE    C(15)    Item sublocation
*-  BIN      C(15)    Item sublocation
*-  LINTYPE  C(1)     Type of BOM Line:
*-                      " " = standard,
*-                      "C" = component,
*-                      "E" = external,
*-                      "M" = modular,
*-                      "P" = phantom,
*-                      "O" = operation,
*-                      "S" = supply (consumable)
*-                      "V" = variable,
*-  QTYTYPE  C(1)     Type of qtys for this line:
*-                      "U" = units,
*-                      "W" = % weight,
*-                      "V" = % volume
*-  LEADOFF  N(4,0)   Production offset
*-  PERUSCR  L        Is scrap quantity used:
*-                      .T. = for each unit of finished good produced
*-                      .F. = only once during assembly
*-  AUTOBO   L        Is component auto-backordered?
*-  BQTYUSD  N(12,3)  Units used (with multiplier) for this line
*-  BQTYSCR  N(12,3)  Units scraped (with multiplier) for this line -
*-                    includes per unit usage calculation
*-  BQTYTOT  N(12,3)  Total units used (with multiplier) for this line
*-  UNTCOST  N(15,5)  Unit cost from inventory
*-  TOTCOST  N(15,5)  Total extended cost (with multiplier) for this line
*----------------------------------------------------------------------------
*- Returns:
*- Variables..: 
*-
*- Parameters.: 
*-
*- Files Open.: Leaves all files open.  Creates second temporary file
*-              with exploded BOM detail in a_tmpf2.  Does not preserve
*-              record pointers or index tags in any file
*----------------------------------------------------------------------------
*- Example:
*-   DO l_expbom WITH ln_factor, ;
*-                    gn_maxlevl, ;
*-                    lc_bomno, ;
*-                    lc_revlev, ;
*-                    gc_cstmeth, ;
*-                    lc_cstloc
*----------------------------------------------------------------------------
PROCEDURE l_expbom

*\ [1 line] PTRs 77087/77254 08/13/04 KGUP Added param po_updic to handle calls from WO/SC
PARAMETERS ln_mult, ;
           ln_maxlev, ;
           lc_bomno, ;
           lc_revlev, ;
           lc_cstmeth, ;
           pc_cstloc, ;
           pc_bomtype, ;
           po_updic

*\ [1 Line] PTR# 70292 06/23/04 TISN Declared variable lc_pfilter
*\ [1 line] PTR 74151 04/06/04 KGUP Create U/M related private variables 
  *-- Declare local variables private
  PRIVATE la_dcst, ;
          la_dkey, ;
          la_dqty, ;
          la_drec, ;
          la_trec, ;
          lc_level, ;
          ln_bqtyscr, ;
          ln_tqtyscr, ;
          ln_umfactscr, ;
          lc_umeasurscr, ;
          ln_bqtyusd, ;
          ln_tqtyusd, ;
          ln_umfactusd, ;
          lc_umeasurusd, ;
          ln_bomcost, ;
          ln_level, ;
          ln_trecno, ;
          ln_untcost, ;
          lc_bomtype, ;
          lc_pfilter

*\ [Begin] PTRs 77087/77254 08/13/04 KGUP Behavioral differences between WO/PE
*\ [Begin] PTR 69148 07/13/05 KGUP Allow variable-in-modular and nested-modular scenarios
  *-- Create a variable to ascertain whether the call is from WO or PE
  LOCAL lc_CalledFrom, ;
        lc_alias, ;
        ln_opnft, ;
        lc_From1, ;
        lc_Where1
  
  LOCAL lc_Temp, ;
        lc_Temp31, ;
        lc_lintype, ;
        lc_ComponentAlias

  IF TYPE("po_updic") = "O"
    *-- The updic object was defined and passed as a parameter.
    *-- Extract details from it, to be used to dictate behavior here.
    lc_CalledFrom = po_updic.sc_CalledFrom
  ELSE
    *-- Called from PE
    lc_CalledFrom = "PE"
  ENDIF
  
  ln_opnft = 0
*\ [End] PTR PTRs 77087/77254 08/13/04 KGUP Behavioral differences between WO/PE
  
  lc_bomtype = IIF(TYPE("pc_bomtype") = "C", pc_bomtype, "")

  *-- Setup level and array pointer variable
  ln_level = 0
  ll_cont = .t.

  *-- Declare array of cost levels for roll-up
  DECLARE la_dcst[ln_maxlev]
  la_dcst = 0

  *-- Declare array of key values for detail explosion
  DECLARE la_dkey[ln_maxlev]
  la_dkey = ""

  *-- Declare array of qty multipliers for detail explosion
  DECLARE la_dqty[ln_maxlev]
  la_dqty = 0

  *-- Declare array of record numbers for detail explosion
  DECLARE la_drec[ln_maxlev]
  la_drec = 0

  *-- Declare array of record numbers in temporary report file
  DECLARE la_trec[ln_maxlev]
  la_trec = 0

  *-- Set index in BOM detail file to BOM number
  go_SQL.cmpA_Pebmdt.m_SetOrder("bomno")

*\ [Begin] PTRs 77087/77254 08/13/04 KGUP Needed to call this subroutine from WO.PRG
  IF lc_CalledFrom = "WO"
    
    IF gl_solink AND go_SQL.m_IsUsed("a_wotran") AND NOT EMPTY(a_wotran->sono)
      lc_alias = ALIAS()
      lc_sono = ALLTRIM(a_wotran->sono)
      ln_opnft = g_opnfl(gf_petranf, "a_petran", .f., .f., "")
      go_SQL.m_TableChangeCurrent(lc_alias)
    ENDIF
    
  ENDIF
*\ [End] PTRs 77087/77254 08/13/04 KGUP Needed to call this subroutine from WO.PRG

  *-- Display processing message
  DO g_dspst WITH "On BOM " + ALLTRIM(lc_bomno) + ", Level " + ;
                  LTRIM(STR(ln_level, 3, 0)), ;
                  Cl_RefrText, gn_msgline, ;
                  "", "", ""

  *-- Clear BOM cost variable
  ln_bomcost = 0

  *-- Add header record for BOM
  go_SQL.m_TableChangeCurrent("a_tmpf2")
  go_SQL.so_CurrentAlias.m_Add()
  go_SQL.so_CurrentAlias.m_ReplaceBulk("survlevel WITH '0', " + ;
                                       "bomno     WITH lc_bomno, " + ;
                                       "revlev    WITH lc_revlev, " + ;
                                       "revbom    WITH '', " + ;
                                       "lintype   WITH lc_bomtype, " + ;
                                       "qtytype   WITH '', " + ;
                                       "peruscr   WITH IIF(TYPE('peruscr') = 'L', .f., gx_false), " + ;
                                       "bqtyusd   WITH ln_mult, " + ;
                                       "bqtyscr   WITH 0, " + ;
                                       "bqtytot   WITH ln_mult")

  *-- Save record number for BOM cost update of top level
  ln_trecno = go_SQL.cmpA_Tmpf2.m_GetRecno()

  *-- Find first detail record in BOM detail file
  go_SQL.m_TableChangeCurrent("a_pebmdt")

*\ [Begin] PTR# 70292 06/23/04 TISN Set filter to the modular bom to which the
*\                                  edited component belongs
*\ [1 Line] PTR# 74205 06/28/04 TISM Set filter if editing modular configuration
  *-- Check for ll_editcfg - editing modular configuration, 
  *-- ll_editcfg would be set in m_prcbrw of PEFBO9.VCX
  IF (TYPE("ll_modbom") = "L" AND ll_modbom) AND ;
     (TYPE("ll_editcfg") = "L" AND ll_editcfg)

    *-- Called from PEFBO9(configuration) for changing the modular bom component

    *-- Capture the current filter
    lc_pfilter = go_SQL.so_CurrentAlias.m_GetFilter()

    *-- Set filter to the modular BOM to which the edited component belongs
    *-- This is required as there may be components belonging to multiple modular
    *-- bom being configured for the finished good. Only the components of the modular
    *-- bom to which the edited component belong should be displayed for reselection
    go_SQL.so_CurrentAlias.m_SetFilter("bomno = ??a_pebmcf->modno OR " + ;
                                       "(item = ??a_pebmcf->modno AND bomno = ??a_pebmhd->bomno)")
  ENDIF
*\ [End]   PTR# 70292 06/23/04 TISN Set filter to the modular bom to which the
*\                                  edited component belongs

*\ [1 Line] PTR# 74992 06/28/04 TISM Changed the index tag to process the components 
*\                                   in the order of bomline number
  *-- Locate components, Use BOMNO tag (bomno + revlev+ bomline), 
  *-- to process the components in the order of bomline number
  go_SQL.so_CurrentAlias.m_Seek(lc_bomno + lc_revlev, "BOMNO")

  *-- If BOM detail found for top level
  IF go_SQL.so_CurrentAlias.m_IsFound()
    *-- Set level to top level
    ln_level = 1

    *-- Save current key in BOM detail file
    la_dkey[ln_level] = a_pebmdt->bomno + a_pebmdt->revlev

    *-- Save current qty multiplier
    la_dqty[ln_level] = ln_mult

    *-- Process all detail records
    DO WHILE ll_cont AND ln_level > 0 AND ln_level <= ln_maxlev
      *-- Update processing message
      DO g_dspst WITH "On BOM " + ALLTRIM(lc_bomno) + ", Level " + ;
                      LTRIM(STR(ln_level, 3, 0)) + ", Item " + ;
                      ALLTRIM(a_pebmdt->item), ;
                      Cl_RefrText, gn_msgline, ;
                      "", "", ""

      *-- Save current position in BOM detail file
      la_drec[ln_level] = go_SQL.cmpA_Pebmdt.m_GetRecno()

      lc_lintype = " "

      DO CASE
        CASE a_pebmdt->lintype = "M"
          *-- Modular component

          *-- Declare local variables
*\ [1 line] PTR None 07/13/05 KGUP Corrected lc_modqty to ln_modqty
          PRIVATE lc_modbom, ;
                  lc_modrev, ;
                  ln_modqty

          *-- Initialize local variables
          lc_modbom = a_pebmdt->item
          lc_modrev = a_pebmdt->revbom

*\ PEPRG502 03 04/11/02 DLAH Correct multiplier when modulars have qty > 1
          *-- Save current qty multiplier for modular
*!*            ln_modqty = a_pebmdt->bqtyusd
          ln_modqty = a_pebmdt->bqtyusd * la_dqty[ln_level]

          *-- Get the temporary table name
          lc_Temp   = go_SQL.m_GetTempTableName(10, "F")
          lc_Temp31 = go_SQL.m_GetTempTableName(31, "F")

          *-- Populate pop-up with data

          DO WHILE .t.          
            *-- This loop handles the possibility that there may be nested Modular BOMs
  
*\ [Begin] PTRs 77087/77254 08/13/04 KGUP Needed to call this subroutine from WO.PRG
            lc_From1 = ""
            lc_Where1 = ""
            
            IF lc_CalledFrom = "WO"
            
              IF gl_solink AND go_SQL.m_IsUsed("a_wotran") AND NOT EMPTY(a_wotran->sono) AND ;
                 go_SQL.cmpA_petran.m_Seek(lc_sono, "sono")
              
                lc_From1 = ", " + (gf_petranf) + " a_petran "
                lc_Where1 = " AND " + ;
                            "a_petran->wbomno = ??lc_modbom AND " + ;
                            "ALLTRIM(a_petran->sono) = ??lc_sono AND " + ;
                            "a_petran->item = a_pebmdt->item"
              
              ENDIF
              
            ENDIF
*\ [End] PTRs 77087/77254 08/13/04 KGUP Needed to call this subroutine from WO.PRG

*\ PEPRG502 04 04/11/02 DLAH Correct multiplier when modulars have qty > 1
*\ [1 line] PTR 75399 06/30/04 KGUP Add Component-UOM-specific data (i.e. t-fields) that will be used later
*\ [1 line] PTR 75399 06/30/04 KGUP Also improved 'scrap per unit' handling in calculating 'required'
*\ [1 line] PTR 76026 07/05/04 TISY Calculated the scrap value.
*\ [1 line] PTRs 77087/77254 08/13/04 KGUP Added lc_From1 & lc_Where1, which are needed by WO calls

            *-- Get a list of components in this Modular BOM
            *-- (Since this SQL asks that the item be present in ICITEM, it excludes nested Modular BOMs)
            go_SQL.m_SQLSelect("a_pebmdt->item, " + ;
                               "a_pebmdt->revbom, " + ;
                               "a_pebmdt->loctid, " + ;
                               "ROUND((" + STR(ln_modqty,12,5) + " * a_pebmdt->bqtyusd) " + ;
                               "+0+ (a_pebmdt->bqtyscr * " + ;
                               "IIF(a_pebmdt->peruscr = .t., " + STR(ln_modqty,12,5) + ", 1)), 5) AS required, " + ;
                               "a_iciloc->lonhand - " + ;
                               "a_iciloc->lsoaloc - " + ;
                               "a_iciloc->lwoaloc +0+ " + ;
                               "a_iciloc->lonordr +0+ " + ;
                               "a_iciloc->lonwkor AS available, " + ;
                               "a_icitem->itmdesc AS descrip, " + ;
                               "(" + STR(ln_modqty,12,5) + " * a_pebmdt->tqtyusd) AS tqtyusd, " + ;
                               "a_pebmdt->tqtyusd AS tqtyusd2, " + ;
                               "a_pebmdt->umfactusd, " + ;
                               "a_pebmdt->umeasurusd, " + ;
                               "a_pebmdt->bqtyscr * IIF(a_pebmdt->peruscr = .t., " + STR(ln_modqty,12,5) + ", 1) AS bqtyscr, " + ;
                               "a_pebmdt->tqtyscr * IIF(a_pebmdt->peruscr = .t., " + STR(ln_modqty,12,5) + ", 1) AS tqtyscr, " + ;
                               "a_pebmdt->umfactscr, " + ;
                               "a_pebmdt->umeasurscr, " + ;
                               "a_pebmdt->lintype " + ;
                               "FROM " + (gf_pebmdtf) + " a_pebmdt, " + ;
                               (gf_icilocf) + " a_iciloc, " + ;
                               (gf_icitemf) + " a_icitem" + ;
                               lc_From1 + ;
                               " WHERE " + ;
                               "a_pebmdt->bomno + a_pebmdt->revlev = " + ;
                               "??lc_modbom + ??lc_modrev " + ;
                               " AND a_pebmdt->item = a_icitem->item AND " + ;
                               "a_pebmdt->item + a_pebmdt->loctid = " + ;
                               "a_iciloc->item + a_iciloc->loctid" + ;
                               lc_Where1, ;
                               "TABLE", lc_Temp)

            go_SQL.so_CurrentAlias.m_CloseTable()
            
            *-- Get a list of nested Modular BOMs within this Modular BOM
            go_SQL.m_SQLSelect("a_pebmdt->item, " + ;
                               "a_pebmdt->revbom, " + ;
                               "a_pebmdt->loctid, " + ;
                               "ROUND((" + STR(ln_modqty,12,5) + " * a_pebmdt->bqtyusd) " + ;
                               "+0+ (a_pebmdt->bqtyscr * " + ;
                               "IIF(a_pebmdt->peruscr = .t., " + STR(ln_modqty,12,5) + ", 1)), 5) AS required, " + ;
                               "0 AS available, " + ;
                               "a_pebmhd->bomdesc AS descrip, " + ;
                               "(" + STR(ln_modqty,12,5) + " * a_pebmdt->tqtyusd) AS tqtyusd, " + ;
                               "a_pebmdt->tqtyusd AS tqtyusd2, " + ;
                               "a_pebmdt->umfactusd, " + ;
                               "a_pebmdt->umeasurusd, " + ;
                               "a_pebmdt->bqtyscr * IIF(a_pebmdt->peruscr = .t., " + STR(ln_modqty,12,5) + ", 1) AS bqtyscr, " + ;
                               "a_pebmdt->tqtyscr * IIF(a_pebmdt->peruscr = .t., " + STR(ln_modqty,12,5) + ", 1) AS tqtyscr, " + ;
                               "a_pebmdt->umfactscr, " + ;
                               "a_pebmdt->umeasurscr, " + ;
                               "a_pebmdt->lintype " + ;
                               "FROM " + (gf_pebmdtf) + " a_pebmdt, " + ;
                               (gf_pebmhdf) + " a_pebmhd " + ;
                               " WHERE " + ;
                               "a_pebmdt->bomno + a_pebmdt->revlev = " + ;
                               "??lc_modbom + ??lc_modrev " + ;
                               "AND a_pebmdt->lintype = 'M' " + ;
                               "AND a_pebmdt->item = a_pebmhd->bomno", ;
                               "TABLE", lc_Temp31)

            go_SQL.so_CurrentAlias.m_CloseTable()

            *-- Open the temporary table created by the first SQL Select
            *-- Then append the 2nd temp table into it
            = g_opnfl(lc_temp, "ac_query", .f., .f., "", .f., "F")

            IF go_SQL.m_IsTableFound(lc_Temp31, "F")
              go_SQL.cmpAc_query.m_SQLAppendFrom(lc_Temp31, "")
              go_SQL.m_DropTempTable(31, "F")
            ENDIF

            *-- Create a temporary index needed for picklist
            go_SQL.so_CurrentAlias.m_CreateIndex("item1", "ITEM", "", .t., .f.)

            WITH g_NewObj("SycTryKey", "SYBROWSE")
              .m_Reset()
              .sc_DataViewID        = "PL_PE_MODULAR"
              .sc_Key               = ""
              .sl_List              = .t.
              .sl_Add               = .f.
              .sl_ReEnter           = .t.
              .sl_Force             = .t.
              .sc_Alias             = "ac_Query"
              .sc_Order             = ""
              .sc_KeyDescription    = ""
              .sc_Caption           = "Highlight modular " + LOWER(gc_cname) + ;
                                      " for " +  ALLTRIM(lc_modbom) + ;
                                      " qty = " + ALLTRIM(STR(la_dqty[ln_level], 12,5)) + ;
                                      " and press <Enter>"
              .sc_FromTableNameFull = go_SQL.cmpAc_Query.sc_TableNameFull
              .sc_FromTableSQLType  = "F"
              .so_sql               = go_SQL
              ln_TryKey             = .m_Run()
            ENDWITH

            *-- Move the record selected from picklist
            IF ln_TryKey > 0
              go_SQL.cmpAc_Query.m_MoveToRecNo(ln_Trykey)

*\ [Begin] PTR# 74085 04/26/04 TISP Cancelling report generation for ESC Key press
            ELSE
              
              *-- Cancel report generation when ESC/Cancel selected
              IF g_getdlg("Cancel report generation?" , 1, 2, "Yes", "No") = 1 ;
                                 AND TYPE('ll_EscPressed') = 'L'
                ll_cont = .f.
                ll_EscPressed = .t.    && ll_EscPressed declared in PEREPT.PRG
              ELSE
                ll_EscPressed = .f.
              ENDIF
*\ [End] PTR# 74085 04/26/04 TISP Cancelling report generation for ESC Key press

            ENDIF
  
            *-- Find item in inventory file
            = go_SQL.cmpA_Icitem.m_Seek(ac_query->item, "")
            = go_SQL.cmpA_Iciloc.m_Seek(ac_query->item + ac_query->loctid, "")

            *-- Have we selected a component, or another Modular BOM?
            lc_lintype = ac_query->lintype

            IF lc_lintype = "M"
              *-- If nested Modular BOM selected, loop again to look deeper
              lc_modbom = ac_query->item
              lc_modrev = ac_query->revbom
              ln_modqty = ac_query->required
              
              *-- Close and drop the temp table, as it will be opened again while looping
              go_SQL.cmpAc_query.m_CloseTable()
              go_SQL.m_DropTable(lc_temp, , "F")

              LOOP

            ELSE
              *-- Component was selected. Exit from the loop.
              EXIT

            ENDIF

          ENDDO

        OTHERWISE
          *-- Standard or variable component

          *-- Find item in inventory files
          = go_SQL.cmpA_Icitem.m_Seek(a_pebmdt->item, "")
          = go_SQL.cmpA_Iciloc.m_Seek(a_pebmdt->item + a_pebmdt->loctid, "")

      ENDCASE

      *-- Get unit cost
      DO CASE
        CASE lc_cstmeth = "A" AND pc_cstloc = "S" AND ;
          NOT go_SQL.cmpA_Iciloc.m_IsEof()
          *-- Weighted average cost for specific location
          ln_untcost = a_iciloc->lavgcst
        CASE lc_cstmeth = "L" AND pc_cstloc = "S" AND ;
          NOT go_SQL.cmpA_Iciloc.m_IsEof()
          *-- Last cost for specific location
          ln_untcost = a_iciloc->llstcst
        CASE lc_cstmeth = "S" AND pc_cstloc = "S" AND ;
          NOT go_SQL.cmpA_Iciloc.m_IsEof()
          *-- Standard cost for specific location
          ln_untcost = a_iciloc->lstdcst
        CASE lc_cstmeth = "L"
          *-- Last cost for all locations
          ln_untcost = a_icitem->lstcost
        CASE lc_cstmeth = "S"
          *-- Standard cost for all locations
          ln_untcost = a_icitem->stdcost
        OTHERWISE
          *-- Weighted average for all locations
          ln_untcost = a_icitem->avgcost
      ENDCASE

      IF a_pebmdt->lintype = "V" OR (a_pebmdt->lintype = "M" AND lc_lintype = "V")
        *-- Variable component, or variable component inside a modular BOM
        
        IF a_pebmdt->lintype = "M" AND lc_lintype = "V"
          lc_ComponentAlias = "ac_query"
        ELSE
          lc_ComponentAlias = "a_pebmdt"
        ENDIF

*\ [Begin] PTR 77254 08/17/04 KGUP Display UOM and Factor in the window
        *-- Declare local variables
        LOCAL ln_qty, ;
              lc_umeasurusd_text, ;
              lc_umeasurusd_display, ;
              ln_umfactusd_display

        *-- Initialize local variables
        IF lc_ComponentAlias = "a_pebmdt"
          ln_qty = &lc_ComponentAlias.->tqtyusd
        ELSE
          ln_qty = &lc_ComponentAlias.->tqtyusd2
        ENDIF
                
        IF gl_UseBOMCompUOM
          *-- Component UOMs are used. Get Component UOM data from PEBMDT
          lc_umeasurusd_text    = "Component U/M"
          lc_umeasurusd_display = &lc_ComponentAlias.->umeasurusd
          ln_umfactusd_display  = &lc_ComponentAlias.->umfactusd
        ELSE
          *-- No component UOMs in use. Get Stock UOM data instead
          lc_umeasurusd_text    = "Stock U/M"
          lc_umeasurusd_display = a_icitem->stkumid
          ln_umfactusd_display  = 1.000
        ENDIF

        *-- Prepare pop-up window
        DEFINE WINDOW lw_bqty ;
                      AT  0, 0 ;
                      SIZE 7.00, 44.00 ;
                      FONT "Courier New", 9 ;
                      FLOAT ;
                      NOCLOSE ;
                      NOGROW ;
                      SYSTEM ;
                      TITLE "Enter variable quantity for " + ;
                            ALLTRIM(&lc_ComponentAlias.->item) ;
                      COLOR RGB(0,0,0,192,192,192) ;
                      ICON FILE LOCFILE("PRO.ICO")

        ACTIVATE WINDOW lw_bqty
        MOVE WINDOW lw_bqty CENTER

        lc_enter=ON("key","ENTER")

        ON KEY LABEL ENTER 

        @ 1, 5  SAY "Quantity to Use" ;
                    FONT "Arial", 9

        @ 3, 5  SAY lc_umeasurusd_text FONT "Arial", 9
        @ 3, 25 SAY PADL(ALLTRIM(lc_umeasurusd_display), 12)

        @ 5, 5  SAY "U/M Factor" FONT "Arial", 9
        @ 5, 25 SAY TRANSFORM(ln_umfactusd_display, "########.###")
        
        @ 1, 25 GET ln_qty ;
                    PICTURE "########.###" ;
                    COLOR RGB(0,0,0,255,255,255)

        *-- Activate GETs
        READ

        ON KEY LABEL ENTER &lc_enter

        *-- Release pop-up window
        RELEASE WINDOW lw_bqty

        *-- Calculate qtys per unit of finished good at this level
*\ [1 line] PTR 77087 08/18/04 KGUP Calculate only tqytusd here, rest later
        ln_tqtyusd = ln_qty * la_dqty[ln_level]
*\ [End] PTR 77254 08/17/04 KGUP Display UOM and Factor in the window

      ELSE
        *-- Standard or modular component

*\ [Begin] PTR 74151 04/06/04 KGUP Get values into the component UOM variables
*\ [Begin] PTR 75399 06/30/04 KGUP Use UOM-specific data in t-fields for modular components
*\ [Begin] PTR 76350 08/04/04 KGUP Calculate ln_bqtyusd as ln_tqtyusd * ln_umfactusd instead of ac_query->required
        *-- Calculate qtys per unit of finished good at this level
        ln_tqtyusd = IIF(a_pebmdt->lintype <> "M", ;
                         a_pebmdt->tqtyusd * la_dqty[ln_level], ;
                         ac_query->tqtyusd)

*\ [1 line] PTR 77087 08/18/04 KGUP Added ENDIF here, as rest of the calculations are common for "V" also
      ENDIF        
*\ [End] PTR 69148 07/13/05 KGUP Allow variable-in-modular and nested-modular scenarios

      ln_umfactusd = IIF(a_pebmdt->lintype <> "M", ;
                         a_pebmdt->umfactusd, ;
                         ac_query->umfactusd)
      
      lc_umeasurusd = IIF(a_pebmdt->lintype <> "M", ;
                          a_pebmdt->umeasurusd, ;
                          ac_query->umeasurusd)
                          
      ln_bqtyusd = ln_tqtyusd * ln_umfactusd
*\ [End] PTR 76350 08/04/04 KGUP Calculate ln_bqtyusd as ln_tqtyusd * ln_umfactusd instead of ac_query->required

*\ [Begin] PTR# 76067 07/07/04 KGUP No scrap recovered when negative PCM is done
      IF ln_mult < 0
      *-- In case of negative PCM, the scrap qty is not recoverable. Set it to zero.
        ln_bqtyscr = 0
        ln_tqtyscr = 0
      
      ELSE
*\ [1 line] PTR 76026 07/05/04 TISY Used the scrap value for Modular BOMs.
        ln_bqtyscr = IIF(a_pebmdt->lintype <> "M", ;
                         a_pebmdt->bqtyscr * IIF(a_pebmdt->peruscr = gx_true, ;
                                                 la_dqty[ln_level], ;
                                                 1), ;
                         ac_query->bqtyscr)

        ln_tqtyscr = IIF(a_pebmdt->lintype <> "M", ;
                         a_pebmdt->tqtyscr * IIF(a_pebmdt->peruscr = gx_true, ;
                                                 la_dqty[ln_level], ;
                                                 1), ;
                         ac_query->tqtyscr)
      ENDIF
*\ [End] PTR# 76067 07/07/04 KGUP No scrap recovered when negative PCM is done
      
      ln_umfactscr = IIF(a_pebmdt->lintype <> "M", ;
                         a_pebmdt->umfactscr, ;
                         ac_query->umfactscr)
      
      lc_umeasurscr = IIF(a_pebmdt->lintype <> "M", ;
                          a_pebmdt->umeasurscr, ;
                          ac_query->umeasurscr)
*\ [End] PTR 75399 06/30/04 KGUP Use UOM-specific data for the modular components
*\ [End] PTR 74151 04/06/04 KGUP Get values into the component UOM variables
*\ [0 lines] PTR 77087 08/18/04 KGUP Removed ENDIF from here (moved it several lines up)

      *-- Prepare level indicator string
      lc_level = LTRIM(STR(ln_level, 3, 0))
      lc_level = SPACE(MIN(ln_level, 12 - LEN(lc_level))) + lc_level

      *-- Add record to temporary detail file
      go_SQL.m_TableChangeCurrent("a_tmpf2")
      go_SQL.so_CurrentAlias.m_Add()
*\ [1 Line] PTR# 76420 08/06/04 TIRA Excluded Scrap Quantity in all components
*\                                   in calculating totcost for Roll-up costs
*\ [1 Line] PTR# 76420 07/26/04 TIRA Excluded Scrap Quantity for a modular component
*\                                   in calculating totcost
      *-- Update from BOM detail
      go_SQL.so_CurrentAlias.m_ReplaceBulk("survlevel WITH lc_level, " + ;
                                           "bomno   WITH IIF(a_pebmdt->lintype <> 'M', lc_bomno, IIF(NOT go_SQL.m_IsUsed('a_petran'), lc_bomno, lc_modbom)), " + ;
                                           "revlev  WITH IIF(a_pebmdt->lintype <> 'M', lc_revlev, IIF(NOT go_SQL.m_IsUsed('a_petran'), ac_query->revbom, lc_modrev)), " + ;
                                           "item    WITH IIF(a_pebmdt->lintype <> 'M', a_pebmdt->item, ac_query->item), " + ;
                                           "revbom  WITH a_pebmdt->revbom, " + ;
                                           "loctid  WITH IIF(a_pebmdt->lintype <> 'M', a_pebmdt->loctid, ac_query->loctid), " + ;
                                           "store   WITH a_pebmdt->store, " + ;
                                           "bin     WITH a_pebmdt->bin, " + ;
                                           "operid  WITH a_pebmdt->operid, " + ;
                                           "wrkcid  WITH a_pebmdt->wrkcid, " + ;
                                           "lintype WITH a_pebmdt->lintype, " + ;
                                           "qtytype WITH a_pebmdt->qtytype, " + ;
                                           "leadoff WITH a_pebmdt->leadoff, " + ;
                                           "peruscr WITH IIF(TYPE('peruscr') = 'L', (a_pebmdt->peruscr = gx_true), a_pebmdt->peruscr), " + ;
                                           "bqtyusd WITH ln_bqtyusd, " + ;
                                           "bqtyscr WITH ln_bqtyscr, " + ;
                                           "bqtytot WITH ln_bqtyusd + ln_bqtyscr, " + ;
                                           "untcost WITH ln_untcost, " + ;
                                           "totcost WITH IIF(lc_costs = 'R', " + ;
                                           "ROUND(ln_untcost * ln_bqtyusd, 5), " + ;
                                           "ROUND(ln_untcost * (ln_bqtyusd + ln_bqtyscr), 5))")

*\ [Begin] PTR 76541 07/24/04 TIVK Include else condition for updation of variable components
*\ [Begin] PTR 74151 04/06/04 KGUP Add component UOM values to the table
*\ [Begin] PTR 77087 08/18/04 KGUP Removed special treatment for the "V" case
      go_SQL.cmpA_tmpf2.m_ReplaceBulk("tqtyusd    WITH ln_tqtyusd, " + ;
                                      "umfactusd  WITH ln_umfactusd, " + ;
                                      "umeasurusd WITH lc_umeasurusd, " + ;
                                      "tqtyscr    WITH ln_tqtyscr, " + ;
                                      "umfactscr  WITH ln_umfactscr, " + ;
                                      "umeasurscr WITH lc_umeasurscr")
*\ [End] PTR 77087 08/18/04 KGUP Removed special treatment for the "V" case
*\ [End] PTR 74151 04/06/04 KGUP Add component UOM values to the table
*\ [End] PTR 76541 07/24/04 TIVK Include else condition for updation of variable components

      IF TYPE("a_tmpf2->autobo") <> "U" AND TYPE("a_pebmdt->autobo") <> "U"
        go_SQL.so_CurrentAlias.m_ReplaceBulk("autobo WITH (a_pebmdt->autobo = gx_true)")
      ENDIF

*\ [3 Lines] PTR# 70292 06/23/04 TISN Update the modular bom to which the edited component belongs
      IF TYPE("a_tmpf2->modno") <> "U"
        go_SQL.so_CurrentAlias.m_ReplaceBulk("modno WITH IIF(a_pebmdt->lintype <> 'M', '', lc_modbom)")
      ENDIF

      *-- For tracking inactive components
      IF TYPE("a_tmpf2->begdate") <> "U" AND TYPE("a_tmpf2->enddate") <> "U"
        go_SQL.so_CurrentAlias.m_ReplaceBulk("begdate WITH a_pebmdt->begdate, " + ;
                                             "enddate WITH a_pebmdt->enddate")
      ENDIF

      *-- Release ac_query from component types
      IF go_SQL.m_IsUsed("ac_query")
        go_SQL.cmpAc_query.m_CloseTable()
        go_SQL.m_DropTable(lc_temp, , "F")
      ENDIF

      *-- Include BOM comments into memo field
      IF TYPE("notes") <> "U"
        go_SQL.so_CurrentAlias.m_ReplaceBulk("notes  WITH a_pebmdt->blnmemo")
      ENDIF

      *-- Save current cost level
      la_dcst[ln_level] = la_dcst[ln_level] + ;
                          ROUND(ln_untcost * (ln_bqtyusd + ln_bqtyscr), 5)

      *-- Save current position in temporary report file
      la_trec[ln_level] = go_SQL.cmpA_Tmpf2.m_GetRecno()

      *-- Search for BOM fin good item record for this BOM detail item
      go_SQL.m_TableChangeCurrent("a_pebmit")
      go_SQL.so_CurrentAlias.m_Seek(a_tmpf2->item, "")

      *-- If subassembly record found and not about to exceed max levels
      IF go_SQL.so_CurrentAlias.m_IsFound() AND ln_level + 1 <= ln_maxlev
        *-- Search for BOM detail for subassembly
        go_SQL.m_TableChangeCurrent("a_pebmdt")
*\[1 Line] PTR# 80399 04/19/06 TINY Change the tagname from bomno1 to bomno
        go_SQL.so_CurrentAlias.m_Seek(a_pebmit->bomno + a_pebmit->revlev, "BOMNO")

        *-- Check for correct revision level
        IF a_pebmit->revlev <> a_tmpf2->revbom
*\[1 Line] PTR# 80399 04/19/06 TINY Change the tagname from bomno1 to bomno
          go_SQL.so_CurrentAlias.m_Seek(a_pebmit->bomno + a_tmpf2->revbom, "BOMNO")
        ENDIF

        *-- If BOM detail for subassembly found
        IF go_SQL.so_CurrentAlias.m_IsFound()

          *-- Reduce cost array for roll-up
          IF lc_costs = "R"
            la_dcst[ln_level] = la_dcst[ln_level] - ;
                                ROUND(ln_untcost * (ln_bqtyusd + ln_bqtyscr), 5)
          ENDIF

          *-- Increment level
          ln_level = ln_level + 1

          *-- Save current key in BOM detail file for new level
          IF a_pebmit->revlev <> a_tmpf2->revbom
            *-- Use revision level in temporary file
            la_dkey[ln_level] = a_pebmit->bomno + a_tmpf2->revbom
          ELSE
            *-- Finished good revision is OK
            la_dkey[ln_level] = a_pebmit->bomno + a_pebmit->revlev
          ENDIF

          *-- Save current qty multiplier
          la_dqty[ln_level] = a_tmpf2->bqtytot

          *-- Check for phantom BOM type
          go_SQL.cmpA_Pebmhd.m_SetOrder("bomno")

          IF go_SQL.cmpA_Pebmhd.m_Seek(la_dkey[ln_level], "") AND ;
            a_pebmhd->bomtype = "P"
            go_SQL.m_TableChangeCurrent("a_tmpf2")
            go_SQL.so_CurrentAlias.m_ReplaceBulk("lintype WITH 'P'")
            go_SQL.m_TableChangeCurrent("a_pebmdt")
          ENDIF

          *-- Restart explosion at next level
          LOOP

        ENDIF && FOUND()

      ENDIF && FOUND() AND ln_level + 1 <= ln_maxlev

      *-- If subassembly not found, increment top level BOM cost
      ln_bomcost = ln_bomcost + a_tmpf2->totcost

      *-- Move to next detail record
      go_SQL.m_TableChangeCurrent("a_pebmdt")

      *-- Go back to prior record in BOM detail file
      go_SQL.so_CurrentAlias.m_MoveToRecno(la_drec[ln_level])

      IF NOT go_SQL.so_CurrentAlias.m_IsEof()
        go_SQL.so_CurrentAlias.m_MoveRecord(Cn_NextRec)
      ENDIF

      *-- If at end of records for this subassembly
      DO WHILE ll_cont AND ln_level > 0 AND ;
        (a_pebmdt->bomno + a_pebmdt->revlev <> la_dkey[ln_level] OR ;
        go_SQL.so_CurrentAlias.m_IsEof())

        *-- Decrement level
        ln_level = ln_level - 1

        *-- If not at top level
        IF ln_level > 0
          *-- Go back to prior record in BOM detail file
          go_SQL.so_CurrentAlias.m_MoveToRecno(la_drec[ln_level])

          *-- Select BOM header record
          go_SQL.m_TableChangeCurrent("a_tmpf2")

          *-- Go back to prior record in temorary report file
          go_SQL.so_CurrentAlias.m_MoveToRecno(la_trec[ln_level])

          *-- Update cost for this level
          DO CASE
            CASE lc_costs = "I"
              *-- Inventory costs

              *-- Find item in inventory files
              = go_SQL.cmpA_Icitem.m_Seek(a_pebmdt->item, "")
              = go_SQL.cmpA_Iciloc.m_Seek(a_pebmdt->item + a_pebmdt->loctid, "")

              *-- Update costs for parent record
              DO CASE
                CASE lc_cstmeth = "A" AND pc_cstloc = "S" AND ;
                     NOT go_SQL.cmpA_Iciloc.m_IsEof()
                  *-- Weighted average cost for specific location
                  go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH a_iciloc->lavgcst, " + ;
                          "totcost WITH ROUND(a_iciloc->lavgcst * bqtytot, 5)")
                CASE lc_cstmeth = "L" AND pc_cstloc = "S" AND ;
                  NOT go_SQL.cmpA_Iciloc.m_IsEof()
                  *-- Last cost for specific location
                  go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH a_iciloc->llstcst, " + ;
                          "totcost WITH ROUND(a_iciloc->llstcst * bqtytot, 5)")
                CASE lc_cstmeth = "S" AND pc_cstloc = "S" AND ;
                  NOT go_SQL.cmpA_Iciloc.m_IsEof()
                  *-- Standard cost for specific location
                  go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH a_iciloc->lstdcst, " + ;
                          "totcost WITH ROUND(a_iciloc->lstdcst * bqtytot, 5)")
                CASE lc_cstmeth = "L"
                  *-- Last cost for all locations
                  go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH a_icitem->lstcost, " + ;
                          "totcost WITH ROUND(a_icitem->lstcost * bqtytot, 5)")
                CASE lc_cstmeth = "S"
                  *-- Standard cost for all locations
                  go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH a_icitem->stdcost, " + ;
                          "totcost WITH ROUND(a_icitem->stdcost * bqtytot, 5)")
                OTHERWISE
                  *-- Weighted average for all locations
                  go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH a_icitem->avgcost, " + ;
                          "totcost WITH ROUND(a_icitem->avgcost * bqtytot, 5)")
              ENDCASE

              *-- Correct top level BOM cost
              ln_bomcost = ln_bomcost - la_dcst[ln_level + 1] + ;
                           a_tmpf2->totcost

            CASE lc_costs = "R"
              *-- Roll-up costs

              *-- Update costs for parent record
              go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH IIF(bqtytot <> 0, ROUND(la_dcst[ln_level + 1] / bqtytot, 5), 0), " + ;
                       "totcost WITH ROUND(la_dcst[ln_level + 1], 5)")

              *-- Update cost array from upper level
              IF ln_level > 0
                la_dcst[ln_level] = la_dcst[ln_level] + la_dcst[ln_level + 1]
              ENDIF

          ENDCASE

          *-- Reset cost of level just completed
          la_dcst[ln_level + 1] = 0

          *-- Select BOM detail file
          go_SQL.m_TableChangeCurrent("a_pebmdt")

          *-- Move to next record
          IF NOT go_SQL.so_CurrentAlias.m_IsEof()
            go_SQL.so_CurrentAlias.m_MoveRecord(Cn_NextRec)
          ENDIF

        ENDIF

        *-- Repeat test for end of detail records
      ENDDO && ll_cont AND ln_level > 0 AND (a_pebmdt->bomno ...

    ENDDO && WHILE ll_cont AND ln_level > 0 AND ln_level <= ln_maxlev

  ENDIF && FOUND()

*\ [3 Lines] PTR# 70292 06/23/04 TISN Reset the filter
*\ [1 Line] PTR# 74205 06/28/04 TISM Restore filter if editing modular configuration
  *-- Restore filter if editing modular configuration
  IF (TYPE("ll_modbom") = "L" AND ll_modbom) AND ;
     (TYPE("ll_editcfg") = "L" AND ll_editcfg)
    go_SQL.cmpA_Pebmdt.m_SetFilter(lc_pfilter)
  ENDIF

*\ [Begin] PTRs 77087/77254 08/13/04 KGUP Needed to call this subroutine from WO.PRG
  IF ln_opnft = 2 AND go_SQL.m_IsUsed("a_petran")
    go_SQL.cmpA_Petran.m_CloseTable()
  ENDIF
*\ [End] PTRs 77087/77254 08/13/04 KGUP Needed to call this subroutine from WO.PRG

  *-- Return to BOM header record in temporary detail file
  go_SQL.m_TableChangeCurrent("a_tmpf2")
  go_SQL.so_CurrentAlias.m_MoveToRecno(ln_trecno)

  *-- Update header record with calculated BOM cost
  go_SQL.so_CurrentAlias.m_ReplaceBulk("untcost WITH IIF(a_tmpf2->bqtyusd <> 0, ROUND(ln_bomcost / a_tmpf2->bqtyusd, 5), 0), " + ;
                                       "totcost WITH ln_bomcost")

  *-- Clear processing message
  DO g_dspst WITH Cc_NullStr, Cl_RefrText, gn_msgline, ;
                  "", "", ""

RETURN
*----------------------------------------------------------------------------
*- End Procedure...: l_expbom
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- Function...: l_selkey()
*----------------------------------------------------------------------------
*- Synopsis...: Validate key value from option grid
*----------------------------------------------------------------------------
*- Calls......: g_dspalt(), g_opnfl(), g_trykey
*----------------------------------------------------------------------------
*- Parameters.: <ExpC>   rc_keyval,  key value to validate
*-              <ExpC>   pc_keyfile, file to use for validation
*-              <ExpC>   pc_keyfld,  field to use for validation
*-              <ExpL>   pl_blankok, if .t., allow blank value
*-              <ExpL>   pl_opendbf, if .t., open .DBF in this function
*-              <ExpL>   pl_closdbf, if .t., close .DBF in this function
*----------------------------------------------------------------------------
*- Returns:
*- Value......: <ExpL>   .t. if valid value
*----------------------------------------------------------------------------
FUNCTION l_selkey

PARAMETERS rc_keyval, ;
           pc_keyfile, ;
           pc_keyfld, ; 
           pl_blankok, ;
           pl_opendbf, ;
           pl_closdbf

  *-- Declare local variables
  PRIVATE lc_brwflds, ;
          lc_filter, ;
          lc_index, ;
          lc_title, ;
          ll_result, ;
          ln_opndbf, ;
          lc_DataViewID

  LOCAL ln_trykey

  *-- Initialize local variables
  ll_result = .f.
  ln_opndbf = 0
  ln_trykey = 0

  DO CASE
    CASE pc_keyfile = "a_glacnt"
      *-- GL account file
      lc_brwflds    = "glacnt :h=[Account]:p = gc_acctpic, ;
                       gldesc :h=[Description]"
      lc_filter     = ""
      lc_index      = "glacnt"
      lc_title      = "GL Account"

      lc_DataViewID = "PL_PEACCOUNT"

      IF pl_opendbf
        ln_opndbf = g_opnfl(gf_glacntf, ;
                           "a_glacnt", ;
                           .f., ;
                           .f., ;
                           "")
      ENDIF

    CASE pc_keyfile = "a_icitem"
      *-- Inventory item master file
      lc_brwflds = "item    :h=[Item], ;
                    itmdesc :h=[Description]"
      lc_filter  = ""
      lc_index   = "item"
      lc_title   = "Item"

      lc_DataViewID = "PL_PEITEM"

      IF pl_opendbf
        ln_opndbf = g_opnfl(gf_icitemf, ;
                           "a_icitem", ;
                           .f., ;
                           .f., ;
                           "")
      ENDIF

    CASE pc_keyfile = "a_icloct"
      *-- Inventory location file
      lc_brwflds = "loctid  :h=gc_locta, ;
                    locdesc :h=[Description]"
      lc_filter  = ""
      lc_index   = "loctid"
      lc_title   = gc_loct

      lc_DataViewID = "PL_PEITLOCT"

      IF pl_opendbf
        ln_opndbf = g_opnfl(gf_icloctf, ;
                           "a_icloct", ;
                           .f., ;
                           .f., ;
                           "loctid")
      ENDIF

    CASE pc_keyfile = "a_pebmhd"
      *-- Bill of material header file
      lc_brwflds = "bomno   :h=gc_babbr + [ Number], ;
                    revlev  :h=gc_vname, ;
                    bomdesc :h=[Description]"
      lc_filter  = ""
      lc_index   = "bomno"
      lc_keyfld  = "bomno"
      lc_title   = gc_babbr + " Number"

      lc_DataViewID = "PL_PEBMHD"

      IF pl_opendbf
        ln_opndbf = g_opnfl(gf_pebmhdf, ;
                            "a_pebmhd", ;
                            .f., ;
                            .f., ;
                            "")
      ENDIF

    CASE pc_keyfile = "a_pebmit" AND pc_keyfld = "bomno" 
      *-- Bill of material item file
      lc_brwflds = "bomno  :h=gc_babbr + [ Number], ;
                    revlev :h=gc_vname"
      lc_filter  = ""
      lc_index   = "bomno"
      lc_keyfld  = "bomno"
      lc_title   = gc_babbr + " Number"

      lc_DataViewID = "PL_PEBMIT1"

      IF pl_opendbf
        ln_opndbf = g_opnfl(gf_pebmitf, ;
                            "a_pebmit", ;
                            .f., ;
                            .f., ;
                            "")
      ENDIF

    CASE pc_keyfile = "a_pebmit" AND pc_keyfld = "fitem"
      *-- Bill of material item file
      lc_brwflds = "fitem :h=gc_fname, " + ;
                   "fiscdesc=IIF(go_SQL.cmpA_Icitem.m_Seek(fitem, ''), a_icitem->itmdesc, '') " + ;
                   ":h=[Description]"
      lc_filter  = ""
      lc_index   = "fitem"
      lc_keyfld  = "fitem"
      lc_title   = gc_fname

      lc_DataViewID = "PL_PEBMIT2"

      IF pl_opendbf
        ln_opndbf = g_opnfl(gf_pebmitf, ;
                            "a_pebmit", ;
                            .f., ;
                            .f., ;
                            "")
      ENDIF

    CASE pc_keyfile = "a_sycrls"
      *-- User file
      lc_brwflds = "chrvl:h=[Rule ID], ;
                    descrip:h=[Description]"
      lc_filter  = "ruleid = 'CLASS' AND compid = '" + gc_compid + "'"
      lc_index   = "ruleid"
      lc_title   = "CLASS"

      lc_DataViewID = "PL_PERULE"

      IF pl_opendbf
        ln_opndbf = g_opnfl(gc_idrvdbf + "SYCRLST" + gc_extdbf, ;
                            "a_sycrls", ;
                            .f., ;
                            .f., ;
                            "")
      ENDIF

    OTHERWISE
      *-- Unsupported alias

      *-- Display alert
      = g_dspalt("Unkown alias passed to L_SETKEY() in PE.PRG.", 3)

      *-- Update result variable
      ll_result = .f.

  ENDCASE

  IF pl_blankok AND LEFT(rc_keyval, 1) <> "?"
    ll_result = .t.
  ELSE

    IF LEFT(rc_keyval, 1) <> "?" AND NOT pl_blankok
      *-- Save current work area
      lc_alias = ALIAS()

      *-- Prepare key file
      go_SQL.m_TableChangeCurrent(pc_keyfile)
      go_SQL.so_CurrentAlias.m_SetFilter(lc_filter)
      go_SQL.so_CurrentAlias.m_SetOrder(lc_index)

      *-- Search for match
      go_SQL.so_CurrentAlias.m_Locate("FOR " + pc_keyfld + " = SUBSTR(??rc_keyval, 1, LEN(??pc_keyfld))")

      *-- Update return variable
      ll_result = go_SQL.so_CurrentAlias.m_IsFound()

      *-- Reselect prior work area
      IF NOT EMPTY(lc_alias)
        go_SQL.m_TableChangeCurrent(lc_alias)
      ENDIF

    ENDIF && LEFT(rc_keyval, 1) <> "?" AND NOT pl_blankok

    *-- If the user selected one, setup to get values below
    IF NOT ll_result

      WITH g_NewObj("SycTryKey", "SYBROWSE")

        .m_Reset()
        .sc_DataViewID        = lc_DataViewID

        .sc_Key               = pc_keyfld

        .sl_List              = ("L" $ "LR" + IIF(rc_keyval = "?", "F", ""))
        .sl_Add               = ("A" $ "LR" + IIF(rc_keyval = "?", "F", ""))
        .sl_ReEnter           = ("R" $ "LR" + IIF(rc_keyval = "?", "F", ""))
        .sl_Blank             = ("B" $ "LR" + IIF(rc_keyval = "?", "F", ""))
        .sl_Force             = ("F" $ "LR" + IIF(rc_keyval = "?", "F", ""))
        .sl_KeyIsName         = ("@" $ "LR" + IIF(rc_keyval = "?", "F", ""))
        .sl_QuestionMarkOK    = ("?" $ "LR" + IIF(rc_keyval = "?", "F", ""))
        .sl_Quiet             = ("Q" $ "LR" + IIF(rc_keyval = "?", "F", ""))

        .sc_Alias             = pc_keyfile
        .sc_Order             = lc_index
        .sc_KeyDescription    = lc_title
        .sc_Filter            = lc_filter
        .sc_FilterDescription = ""
        .sc_ErrMsg            = ""

        .so_sql               = go_SQL
        ln_trykey = .m_Run()

      ENDWITH

    ENDIF

    IF NOT ll_result AND ln_trykey > 0
      ll_result = .t.
      rc_keyval = &pc_keyfile..&pc_keyfld.
      SHOW GET rc_keyval
    ENDIF

    IF ln_opndbf = 2 AND go_SQL.m_IsUsed(pc_keyfile)
      go_SQL.cmp&pc_Keyfile..m_CloseTable()
    ENDIF

    IF NOT ll_result AND LEFT(rc_keyval, 1) = "?"
      *-- Clear "?" from field
      KEYBOARD "{CTRL+Y}" PLAIN
    ENDIF

  ENDIF && pl_blankok AND LEFT(pc_keyval, 1) <> "?"

RETURN (ll_result)
*----------------------------------------------------------------------------
*- End Function...: l_selkey()
*----------------------------------------------------------------------------

*----------------------------------------------------------------------------
*- File Name..: $Workfile:   pe.prg  $
*- Total Lines: 3242